/*===========================================================================*/
/*                                                                           */
/*                    Mind version 7.0 runtime library                       */
/*                                                                           */
/*                 Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*  t@C: 2KERU.c (kernel.c̃CN[ht@C)                     */
/*  @\      : 񑀍̂AUnicodeUCS2`                */
/*  쐬      : Ћ (2016.12.27)                                          */
/*---------------------------------------------------------------------------*/


/* L^ -/
2016.12.27	UnicodeUCS2`iC/ǉꏊ́utvŌj
		(MindSearchIIĨ\[X]p)
/- I */



  #if UCS2_BE
  /* big endian */
#define	PUSH_1ST_CHAR_UCS2 \
	PUSH_Q( (USHORT)(string[0])<<8 | string[1], 0 )

#define	PUSH_LAST_CHAR_UCS2 \
	PUSH_Q( (USHORT)(*(strNext-2))<<8 | *(strNext-1), 0 )

  #else
  /* little endian */
#define	PUSH_1ST_CHAR_UCS2 \
	PUSH_Q( string[0] | (USHORT)(string[1])<<8, 0 )

#define	PUSH_LAST_CHAR_UCS2 \
	PUSH_Q( *(strNext-2) | (USHORT)(*(strNext-1))<<8, 0 )
  #endif


PRIVATE size_t			/* ߒl:ɑoCg */
    u_countMojisu(
		size_t		length,		/* 1:񒷂 */
		size_t		reqChars	/* 2:v */
	           )
{
		size_t		reqBytes;

	reqBytes = reqChars * 2;
	if ( reqBytes > length )
	{
		reqBytes = length;
	}
	return reqBytes;
}


/*-----------------------------------------------------------------------------
                                   $$UC-S (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    zzUCtoS( void )              /* ;WORD $$UC-S .N */
{
        /* (unichr   chr, strinfo) */

		USHORT	wideChar;
		LONG   *stackPtr;

	/* ------------------------------------------------ */
	/* R[ȟnbig/littleGfBAɈˑ */
	/* ------------------------------------------------ */

	stackPtr = DstackPointer+1;	  /* FstackPtr=AhX */
	wideChar = (USHORT)READ_U_OF_Q;
	if ( IamBigEndian == UCS2_BE )
	{
		if ( IamBigEndian )
		{
			/*  big endian */
			PUSH_S( ((UCHAR *)stackPtr)+2, 2 );	/* 2bytew */
		}
		else
		{
			/*  little endian */
			PUSH_S( (UCHAR *)stackPtr, 2 );		/* wideCharʒuw */
		}
	}
	else
	{
		WRITE_U_OF_Q( (USHORT)(wideChar<<8) | (USHORT)(wideChar>>8) );
		if ( IamBigEndian )
		{
			/* Iam big, UCS2 is little */
			PUSH_S( ((UCHAR *)stackPtr)+2, 2 );	/* 2bytew */
		}
		else
		{
			/* Iam little, UCS2 is big */
			PUSH_S( (UCHAR *)stackPtr, 2 );		/* wideCharʒuw */
		}
	}
}



/*-----------------------------------------------------------------------------
                      擪^ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE	size_t				/* ߒl:팸oCg */
    u_limitLength(
		size_t		 length,	/* 1:񒷂 */
		size_t		 limit		/* 2:   */
	     )
{
		size_t	 deleted;

	deleted = 0;
	if ( length > limit )
	{
		/*   ~bg */
		limit &= -2;		/*  */
		/*printf( "␮lenght=%d\n", limit );*/  /*TEST*/
		deleted = length - limit;
	}
	return deleted;
}

PRIVATE void
    u_sentoKetasuSeigen( void )		/* ;WORD t擪  SN */
{
	/* (strinfo, length  strinfo, 1/0(L)) */

		size_t		 length;
		UCHAR		*string;
		size_t		 limit;
		size_t		 deleted;

	limit = POP_U_OF_Q;				/* pop */
	READ_length_and_string;				/* 擾 */
	deleted = u_limitLength( length, limit );
	DELETE_NBYTE( TOS, deleted );			/* k */
	PUSH_Q( (deleted != 0), 0 );			/* ʂpush   */
}

PRIVATE void
    u_matubiKetasuSeigen( void )	/* ;WORD t  SN */
{
	/* (strinfo, length  strinfo, 1/0(L)) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 limit;
		size_t		 deleted;

	limit = POP_U_OF_Q;				/* pop */
	READ_length_and_strNext;			/* 擾 */
	deleted = u_limitLength( length, limit );
	DELETE_NBYTE_RIGHT( TOS, deleted );		/* k */
	PUSH_Q( (deleted != 0), 0 );			/* ʂpush   */
}



/*-----------------------------------------------------------------------------
                        ̕ϐւ̊i[ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_popJvar_0(
    		tGeneralPointer  varAddr,	/* 1:ϐAhX */
    		size_t		 varLength	/* 2:ϐ     */
    	     )
{
        /* (strinfo  .) */

		size_t		 length;
		UCHAR		*string;
		size_t		 deleted;

        /*-[ϐ]----------------------*/
        /*   +0(D): length             */
        /*   +4(D): margin             */
        /*   +6(B): "string"           */
        /*-----------------------------*/

	/*printf( "u_popJvar_0 Ă΂ꂽ\n" );*/  /*TEST*/
	/* ̎o */
	POP_length_and_string;
	
	/* i[̌̕ */
	if ( length > varLength )
	{	/* ǉϐ蒷 */
		deleted = u_limitLength( length, varLength );
		length -= deleted;		/* ǉk */
	}

        /* wb_L */
        varAddr.u[0] = length;
        varAddr.u[1] = 0;

        /* {̕] */
	if ( length )
        {	/* ------------------------------------- */
        	/* :Ŝߒ[̏ꍇ͌Ă΂Ȃ */
		/* ------------------------------------- */
		memmove( &(varAddr.u[2]), (void *)string, length );
        }
}

PRIVATE void
    u_mojiretuJittaiWoIre( void )	/* ;WORD t .J XSW WRT HE */
{
	/* (strinfo, varinfo  .) */

    		tGeneralPointer  varAddr;
    		size_t	 	 varLength;

	varLength = POP_C;
        varAddr.b = POP_A;

	/* i[֐Ă */
    	u_popJvar_0( varAddr, varLength );
}



/*-----------------------------------------------------------------------------
                              tꕶǉ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void				/* ߒl: */
    u_itiMojiTuika_0_Right(
    		tGeneralPointer	varAddress,	/* 1:ϐAhX */
		ULONG	        varLength	/* 2:ϐ     */
		        )
{
		size_t	curLength;
		USHORT	wideChar;		/* Sp̂Ƃ */
		UCHAR	*string;
		size_t	leftMargin;
		LONG	rightMargin;		/* ̒l */

	/* (char(16)  .) */

        /*-[ϐ]----------------------*/
        /*   +0(D): curLength          */  /* [varAddress] */
        /*   +4(D): leftMargin         */
        /*   +6(B): "___string_____"   */
	/*                         */
	/*     leftMargin  rightMargin */
        /*-----------------------------*/

	/* o */
	wideChar = POP_U_OF_Q;

	/* ǉ]T(E)vZ */
	curLength   = varAddress.u[0];
	leftMargin  = varAddress.u[1];
	rightMargin = varLength - leftMargin - curLength;
        string      = (UCHAR *)&(varAddress.u[2]) + leftMargin + curLength;

	if ( rightMargin >= 2 )
	{
		if ( UCS2_BE )
		{
			/* big endian */
			string[0] = wideChar >> 8;        /* ʃoCg */
			string[1] = wideChar & 0xff;      /* ʃoCg */
		}
		else
		{
			/* little endian */
			string[0] = wideChar & 0xff;      /* ʃoCg */
			string[1] = wideChar >> 8;        /* ʃoCg */
		}
		varAddress.u[0] += 2;		  /* JEg𑝉 */
	}
}


PRIVATE void
    u_itiMojiTuika( void )		/* ;WORD tꕶǉ WRT NJ ST HE */
{
	/* (char(16), [AccessPointer()]  .) */

		size_t	        varLength;

        /*-[Mcode]-----------------*/
        /*   +0(D): size(32)           */
        /*-----------------------------*/

	/* ϐm */
	varLength = FETCH_MCODE_LONG;

	/* ǉ(E) */
    	u_itiMojiTuika_0_Right( AccessPointer, varLength );
}

PRIVATE void
    u_itiMojiTuikaForJinfo( void )	/* ;DUMMYWORD */
					/* (ȀoR) */
{
	/* (char(16), [AccessPointer(̏)]  .) */

    		tGeneralPointer	varAddress;
		size_t	        varLength;

	/* ϐǂŎ̕ϐ̃AhXƒ𓾂 */
	varLength    = AccessPointer.u[0];
	varAddress.b = (UCHAR *)(AccessPointer.u[1]);

	/* ǉ(E) */
    	u_itiMojiTuika_0_Right( varAddress, varLength );
}



/*-----------------------------------------------------------------------------
                            tꕶǉ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void				/* ߒl: */
    u_itiMojiTuika_0_Left(
    		tGeneralPointer	varAddress	/* :ϐAhX */
		       )
{
		USHORT	wideChar;		/* Sp̂Ƃ */
		UCHAR	*string;
		size_t	leftMargin;

	/* (char(16)  .) */

        /*-[ϐ]----------------------*/
        /*   +0(D): curLength          */  /* [varAddress] */
        /*   +4(D): leftMargin         */
        /*   +6(B): "___string_____"   */
	/*                         */
	/*     leftMargin  rightMargin */
        /*-----------------------------*/

	/* o */
	wideChar = POP_U_OF_Q;

	/* ǉ]T()vZ */
	leftMargin  = varAddress.u[1];
        string      = (UCHAR *)&(varAddress.u[2]) + leftMargin;

	if ( leftMargin >= 2 )
	{
		string -= 2;		           /*Q߂*/
		if ( UCS2_BE )
		{
			/* big endian */
			string[0] = wideChar >> 8;         /* ʃoCg */
			string[1] = wideChar & 0xff;       /* ʃoCg */
		}
		else
		{
			/* little endian */
			string[0] = wideChar & 0xff;       /* ʃoCg */
			string[1] = wideChar >> 8;         /* ʃoCg */
		}
		varAddress.u[0] += 2;		   /* JEg𑝉 */
		varAddress.u[1] -= 2;		   /* ItZbg */
	}
}


PRIVATE void
    u_itiMojiHigaTuika( void )	    /* ;WORD tꕶǉ WRT NJ ST HE */
{
	/* (char(16), [AccessPointer()]  .) */

        /*-[Mcode]-----------------*/
        /*   +0(D): size(32)           */  /* ̕ϐ͎gȂ */
        /*-----------------------------*/

	/* ϐ̂Ă */
	SKIP_MCODE_1LONG;

	/* Ɉꕶ */
    	u_itiMojiTuika_0_Left( AccessPointer );
}

PRIVATE void
    u_itiMojiHigaTuikaForJinfo( void )	    /* ;DUMMYWORD */
					    /* (ȀoR) */
{
	/* (char(16), [AccessPointer(̏)]  .) */

    		tGeneralPointer	varAddress;

	/* ϐǂŎ̕ϐ̃AhXƒ𓾂 */
	varAddress.b = (UCHAR *)(AccessPointer.u[1]);

	/* Ɉꕶ */
    	u_itiMojiTuika_0_Left( varAddress );
}



/*-----------------------------------------------------------------------------
                               tǉ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void				/* ߒl: */
    u_tuika_0_Right(
    		tGeneralPointer	varAddress,	/* 1:ϐAhX */
		ULONG	        varLength	/* 2:ϐ     */
		 )
{
		size_t		 length;
		UCHAR		*string;
		size_t		 deleted;
		size_t		 curLength;
		UCHAR		*target;
		size_t		 leftMargin;
		LONG		 rightMargin;		/* ̒l */

	/* (strinfo  .) */

        /*-[ϐ]----------------------*/
        /*   +0(D): curLength          */  /* [varAddress] */
        /*   +4(D): leftMargin         */
        /*   +6(B): "___original___"   */
	/*                         */
	/*     leftMargin  rightMargin */
        /*-----------------------------*/

	/* ̎o */
	POP_length_and_string;
	
	/* ǉ]T(E)vZ */
	curLength   = varAddress.u[0];
	leftMargin  = varAddress.u[1];
	rightMargin = varLength - leftMargin - curLength;

	/* nꂽ񂪋܂͒ǉ]T͖̎ */
	if ( length == 0 || rightMargin <= 0 )
	{
		return;
	}

	/* ǉ񂪒ꍇ͏k */
	if ( length > rightMargin )
	{	/* ǉϐ蒷 */
		deleted = u_limitLength( length, rightMargin );
		length -= deleted;			/* ǉk */
	}

	/* ǉ(E) */
	if ( length )
	{
		target = (UCHAR *)&(varAddress.u[2]) + leftMargin + curLength;
		memcpy( (void *)target, (void *)string, length );
		varAddress.u[0] += length;		/* JEg𑝉 */
	}
}


PRIVATE void
    u_tuika( void )		/* ;WORD tǉ WRT SJ ST HE */
{
	/* (strinfo, [AccessPointer()]  .) */

		size_t	        varLength;

        /*-[Mcode]-----------------*/
        /*   +0(D): size(32)           */
        /*-----------------------------*/

	/* ϐm */
	varLength = FETCH_MCODE_LONG;

	/* ǉ(E) */
    	u_tuika_0_Right( AccessPointer, varLength );
}

PRIVATE void
    u_tuikaForJinfo( void )		/* ;DUMMYWORD */
					/* (ȀoR) */
{
	/* (strinfo, [AccessPointer(̏)]  .) */

    		tGeneralPointer	varAddress;
		ULONG	        varLength;

	/* ϐǂŎ̕ϐ̃AhXƒ𓾂 */
	varLength    = AccessPointer.u[0];
	varAddress.b = (UCHAR *)(AccessPointer.u[1]);

	/* ǉ(E) */
    	u_tuika_0_Right( varAddress, varLength );
}



/*-----------------------------------------------------------------------------
                           tǉ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void				/* ߒl: */
    u_tuika_0_Left(
    		tGeneralPointer	varAddress	/* :ϐAhX */
		)
{
		size_t		 length;
		UCHAR		*string;
		size_t		 deleted;
		UCHAR		*target;
		size_t		 leftMargin;

	/* (strinfo  .) */

        /*-[ϐ]----------------------*/
        /*   +0(D): curLength          */  /* [varAddress] */
        /*   +4(D): leftMargin         */
        /*   +6(B): "___original___"   */
	/*                         */
	/*     leftMargin  rightMargin */
        /*-----------------------------*/

	/* ̎o */
	POP_length_and_string;

	/* ǉ]T()vZ */
	leftMargin  = varAddress.u[1];

	/* nꂽ񂪋܂͒ǉ]T͖̎ */
	if ( length == 0 || leftMargin == 0 )
	{
		return;
	}

	/* ǉ񂪒ꍇ͏k */
	if ( length > leftMargin )
	{	/* ǉϐ蒷Jbg */
		deleted = u_limitLength( length, leftMargin );
		string += deleted;			/* ǉk */
		length -= deleted;
	}

	/* ǉ() */
	if ( length )
	{
		target = (UCHAR *)&(varAddress.u[2]) + leftMargin - length;
		memcpy( (void *)target, (void *)string, length );
		varAddress.u[0] += length;		/* JEg𑝉 */
		varAddress.u[1] -= length;		/* }[W */
	}
}


PRIVATE void
    u_higaTuika( void )		/* ;WORD tǉ WRT SJ ST HE */
{
	/* (strinfo, [AccessPointer()]  .) */

        /*-[Mcode]-----------------*/
        /*   +0(D): size(32)           */  /* ̕ϐ͎gȂ */
        /*-----------------------------*/

	/* ϐ̂Ă */
	SKIP_MCODE_1LONG;

	/* ǉ() */
    	u_tuika_0_Left( AccessPointer );
}

PRIVATE void
    u_higaTuikaForJinfo( void )		/* ;DUMMYWORD */
					/* (ȀoR) */
{
	/* (strinfo, [AccessPointer(̏)]  .) */

    		tGeneralPointer	varAddress;

	/* ϐǂŎ̕ϐ̃AhXƒ𓾂 */
	varAddress.b = (UCHAR *)(AccessPointer.u[1]);

	/* ǉ(E) */
    	u_tuika_0_Left( varAddress );
}



/*-----------------------------------------------------------------------------
                             ꕶ폜 (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_itiMojiSakujyo_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string,	/* 2:AhX */
		ULONG		*svar		/* 3:ϐAhX */
		    )
{
	RETURN_IF( length < 2 )		/* 2oCgɖȂȂ炱ŏI */
	DELETE_2BYTE( svar );
}


/* --------------------------------------- */
PRIVATE void
    u_itiMojiSakujyoForJvar( void )		/* ;DUMMYWORD */
{
        /* ([AccessPointer(̕ϐ)]  .) */

		size_t		 length;
		UCHAR		*string;

	SETUP_STRING_LEFT_FOR_JVAR;
	u_itiMojiSakujyo_0( length, string, AccessPointer.u );
}

PRIVATE void
    u_itiMojiSakujyo( void )		/* ;WORD tꕶ폜 WRT .V ST WO */
{
        /* ([AccessPointer(ϐ)]  .) */

		size_t		 length;
		UCHAR		*string;

	SETUP_STRING_LEFT_FOR_SVAR;
	u_itiMojiSakujyo_0( length, string, AccessPointer.u );
}

PRIVATE void
    u_itiMojiSakujyoForJinfo( void )		/* ;DUMMYWORD */
{
        /* ([AccessPointer(̏)]  .) */

		size_t		 length;
		UCHAR		*string;
		ULONG		*svar;

	SETUP_STRING_LEFT_FOR_JINFO;
	u_itiMojiSakujyo_0( length, string, svar );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                           ꕶE폜 (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_itiMojiMigiSakujyo_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*strNext,	/* 2:NEXTAhX */
		ULONG		*svar		/* 3:ϐAhX */
			)
{
        if ( length >= 2 )
        {
		DELETE_2BYTE_RIGHT( svar );
	}
}


/* --------------------------------------- */
PRIVATE void
    u_itiMojiMigiSakujyoForJvar( void )		/* ;DUMMYWORD */
{
        /* ([AccessPointer(̕ϐ)]  .) */

		size_t		 length;
		UCHAR		*strNext;

	SETUP_STRING_RIGHT_FOR_JVAR;
	u_itiMojiMigiSakujyo_0( length, strNext, AccessPointer.u );
}

PRIVATE void
    u_itiMojiMigiSakujyo( void )	  /* ;WORD tꕶE폜 WRT .V ST WO */
{
        /* ([AccessPointer(ϐ)]  .) */

		size_t		 length;
		UCHAR		*strNext;

	SETUP_STRING_RIGHT_FOR_SVAR;
	u_itiMojiMigiSakujyo_0( length, strNext, AccessPointer.u );
}

PRIVATE void
    u_itiMojiMigiSakujyoForJinfo( void )		/* ;DUMMYWORD */
{
        /* ([AccessPointer(̏)]  .) */

		size_t		 length;
		UCHAR		*strNext;
		ULONG		*svar;

	SETUP_STRING_RIGHT_FOR_JINFO;
	u_itiMojiMigiSakujyo_0( length, strNext, svar );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                          ꕶ؂o (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_itiMojiKiridasi_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string,	/* 2:AhX */
		ULONG		*svar		/* 3:ϐAhX */
		     )
{
	/* (.  uchar16) */

	PUSH_0_AND_RETURN_IF( length < 2 )	/* Ȃ0pushĖ߂ */

	PUSH_1ST_CHAR_UCS2;
	DELETE_2BYTE( svar );
}


/* --------------------------------------- */
PRIVATE void
    u_itiMojiKiridasiForJvar( void )	/* ;DUMMYWORD */
{
        /* ([AccessPointer(̕ϐ)]  uchar16) */

		size_t		 length;
		UCHAR		*string;

	SETUP_STRING_LEFT_FOR_JVAR;
	u_itiMojiKiridasi_0( length, string, AccessPointer.u );
}


PRIVATE void
    u_itiMojiKiridasi( void )	    /* ;WORD tꕶ؂o WRT .V ST WO */
{
        /* ([AccessPointer(ϐ)]  uchar16) */

		size_t		 length;
		UCHAR		*string;

	SETUP_STRING_LEFT_FOR_SVAR;
	u_itiMojiKiridasi_0( length, string, AccessPointer.u );
}

PRIVATE void
    u_itiMojiKiridasiForJinfo( void )	/* ;DUMMYWORD */
{
        /* ([AccessPointer(̏)]  uchar16) */

		size_t		 length;
		UCHAR		*string;
		ULONG		*svar;

	SETUP_STRING_LEFT_FOR_JINFO;
	u_itiMojiKiridasi_0( length, string, svar );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                           tꕶE؂o (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_itiMojiMigiKiridasi_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*strNext,	/* 2:NEXTAhX */
		ULONG		*svar		/* 3:ϐAhX */
			 )
{
	/* (.  uchar16) */

	PUSH_0_AND_RETURN_IF( length < 2 )	/* Ȃ0pushĖ߂ */

	PUSH_LAST_CHAR_UCS2;
	DELETE_2BYTE_RIGHT( svar );
}


/* --------------------------------------- */
PRIVATE void
    u_itiMojiMigiKiridasiForJvar( void )		/* ;DUMMYWORD */
{
        /* ([AccessPointer(̕ϐ)]  uchr16) */

		size_t		 length;
		UCHAR		*strNext;

	SETUP_STRING_RIGHT_FOR_JVAR;
	u_itiMojiMigiKiridasi_0( length, strNext, AccessPointer.u );
}


PRIVATE void
    u_itiMojiMigiKiridasi( void )   /* ;WORD tꕶE؂o WRT .V ST WO */
{
        /* ([AccessPointer(ϐ)]  uchr16) */

		size_t		 length;
		UCHAR		*strNext;

	SETUP_STRING_RIGHT_FOR_SVAR;
	u_itiMojiMigiKiridasi_0( length, strNext, AccessPointer.u );
}

PRIVATE void
    u_itiMojiMigiKiridasiForJinfo( void )		/* ;DUMMYWORD */
{
        /* ([AccessPointer(̏)]  uchr16) */

		size_t		 length;
		UCHAR		*strNext;
		ULONG		*svar;

	SETUP_STRING_RIGHT_FOR_JINFO;
	u_itiMojiMigiKiridasi_0( length, strNext, svar );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                            t؂o (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_kiridasi_Left_0(
                size_t           length,        /* 1:񒷂 */
                UCHAR           *string,        /* 2:AhX */
                ULONG           *svar,          /* 3:ϐAhX */
                size_t           reqChars       /* 4:v */
	           )
{
        /* (.  strinfo) */

		size_t		bytes;		/* oCg */

	bytes = u_countMojisu( length, reqChars );
	PUSH_S( string, bytes );
	DELETE_NBYTE( svar, bytes );
}


/* --------------------------------------- */
PRIVATE void
    u_kiridasiForJvar( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̕ϐ)]  strinfo) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	SETUP_STRING_LEFT_FOR_JVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_kiridasi_Left_0( length, string, AccessPointer.u, reqChars );
}

PRIVATE void
    u_kiridasi( void )		/* ;WORD t؂o WRT NV ST WO */
{
        /* (, [AccessPointer(ϐ)]  strinfo) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	SETUP_STRING_LEFT_FOR_SVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_kiridasi_Left_0( length, string, AccessPointer.u, reqChars );
}

PRIVATE void
    u_kiridasiForJinfo( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̏)]  string) */

		size_t		 length;
		UCHAR		*string;
		ULONG		*svar;
		size_t		 reqChars;

	SETUP_STRING_LEFT_FOR_JINFO;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_kiridasi_Left_0( length, string, svar, reqChars );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                          tE؂o (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_kiridasi_Right_0(
                size_t           length,        /* 1:񒷂 */
                UCHAR           *strNext,       /* 2:NEXTAhX */
                ULONG           *svar,          /* 3:ϐAhX */
                size_t           reqChars       /* 4:v */
	            )
{
	/* (.  strinfo) */

		size_t		bytes;		/* oCg */

	bytes = u_countMojisu( length, reqChars );
	PUSH_S( (strNext - bytes), bytes );
	DELETE_NBYTE_RIGHT( svar, bytes );
}


/* --------------------------------------- */
PRIVATE void
    u_migiKiridasiForJvar( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̕ϐ)]  strinfo) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	SETUP_STRING_RIGHT_FOR_JVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_kiridasi_Right_0( length, strNext, AccessPointer.u, reqChars );
}

PRIVATE void
    u_migiKiridasi( void )		/* ;WORD tE؂o WRT NV ST WO */
{
        /* (, [AccessPointer(ϐ)]  strinfo) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	SETUP_STRING_RIGHT_FOR_SVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_kiridasi_Right_0( length, strNext, AccessPointer.u, reqChars );
}

PRIVATE void
    u_migiKiridasiForJinfo( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̏)]  strNext) */

		size_t		 length;
		UCHAR		*strNext;
		ULONG		*svar;
		size_t		 reqChars;

	SETUP_STRING_RIGHT_FOR_JINFO;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_kiridasi_Right_0( length, strNext, svar, reqChars );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                               f (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_bundan_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string,	/* 2:AhX */
		ULONG		*svar,		/* 3:ϐAhX */
		size_t		reqPos		/* 4:ʒu */
	    )
{
	/* (.  strinfo) */

		size_t		bytes;		/* oCg */

	if ( reqPos == 0 || length < 2 )
	{	/* ʒuO */
		PUSH_S( string, 0 );		/* push */
		return;				/* ^[       */
	}

	if ( reqPos == 1 )
	{	/* ʒuP */
		PUSH_S( string, 0 );		/* push */
	}					/* ɐi       */
	else
	{	/* ʒuQ */
		/* [-1]ɑoCg؂o */
		bytes = u_countMojisu( length, (reqPos - 1) );
		PUSH_S( string, bytes );
		DELETE_NBYTE( svar, bytes );
		string += bytes;		/* ̂Qs͎̏ */
		length -= bytes;		/* ̈ꕶ폜ɕKv */
	}

	/* cϐɈꕶ폜 */
	RETURN_IF( length < 2 )		/* 2oCgɖȂȂ炱ŏI */
	DELETE_2BYTE( svar );
}


/* --------------------------------------- */
PRIVATE void
    u_bundanForJvar( void )		/* ;DUMMYWORD */
{
        /* (ʒu, [AccessPointer(̕ϐ)]  strinfo) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqPos;

	SETUP_STRING_LEFT_FOR_JVAR;
	reqPos = POP_U_OF_Q;			/* ʒupop */
	u_bundan_0( length, string, AccessPointer.u, reqPos );
}

PRIVATE void
    u_bundan( void )		/* ;WORD tf WRT NV ST WO */
{
        /* (ʒu, [AccessPointer(ϐ)]  strinfo) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqPos;

	SETUP_STRING_LEFT_FOR_SVAR;
	reqPos = POP_U_OF_Q;			/* ʒupop */
	u_bundan_0( length, string, AccessPointer.u, reqPos );
}

PRIVATE void
    u_bundanForJinfo( void )		/* ;DUMMYWORD */
{
        /* (ʒu, [AccessPointer(̏)]  string) */

		size_t		 length;
		UCHAR		*string;
		ULONG		*svar;
		size_t		 reqPos;

	SETUP_STRING_LEFT_FOR_JINFO;
	reqPos = POP_U_OF_Q;			/* ʒupop */
	u_bundan_0( length, string, svar, reqPos );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                              t폜 (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_sakujyo_Left_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string,	/* 2:AhX */
		ULONG		*svar,		/* 3:ϐAhX */
		size_t		 reqChars	/* 4:v */
	          )
{
	/* (.  .) */

		size_t		bytes;		/* oCg */

	bytes = u_countMojisu( length, reqChars );
	DELETE_NBYTE( svar, bytes );
}


/* --------------------------------------- */
PRIVATE void
    u_sakujyoForJvar( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̕ϐ)]  .) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	SETUP_STRING_LEFT_FOR_JVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_sakujyo_Left_0( length, string, AccessPointer.u, reqChars );
}

PRIVATE void
    u_sakujyo( void )		/* ;WORD t폜 WRT NV ST WO */
{
        /* (, [AccessPointer(ϐ)]  .) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	SETUP_STRING_LEFT_FOR_SVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_sakujyo_Left_0( length, string, AccessPointer.u, reqChars );
}

PRIVATE void
    u_sakujyoForJinfo( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̏)]  .) */

		size_t		 length;
		UCHAR		*string;
		ULONG		*svar;
		size_t		 reqChars;

	SETUP_STRING_LEFT_FOR_JINFO;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_sakujyo_Left_0( length, string, svar, reqChars );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                            tE폜 (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_sakujyo_Right_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*strNext,	/* 2:NEXTAhX */
		ULONG		*svar,		/* 3:ϐAhX */
		size_t		 reqChars	/* 4:v */
	           )
{
	/* (.  .) */

		size_t		 bytes;		/* oCg */

	bytes = u_countMojisu( length, reqChars );
	DELETE_NBYTE_RIGHT( svar, bytes );
}


/* --------------------------------------- */
PRIVATE void
    u_migiSakujyoForJvar( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̕ϐ)]  .) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	SETUP_STRING_RIGHT_FOR_JVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_sakujyo_Right_0( length, strNext, AccessPointer.u, reqChars );
}

PRIVATE void
    u_migiSakujyo( void )		/* ;WORD tE폜 WRT NV ST WO */
{
        /* (, [AccessPointer(ϐ)]  .) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	SETUP_STRING_RIGHT_FOR_SVAR;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_sakujyo_Right_0( length, strNext, AccessPointer.u, reqChars );
}


PRIVATE void
    u_migiSakujyoForJinfo( void )		/* ;DUMMYWORD */
{
        /* (, [AccessPointer(̏)]  .) */

		size_t		 length;
		UCHAR		*strNext;
		ULONG		*svar;
		size_t		 reqChars;

	SETUP_STRING_RIGHT_FOR_JINFO;
	reqChars = POP_U_OF_Q;			/* vpop */
	u_sakujyo_Right_0( length, strNext, svar, reqChars );
}
/* --------------------------------------- */



/*-----------------------------------------------------------------------------
                                t (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_mojisu_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string		/* 2:AhX */
	    )
{
        /* (.  count) */

		size_t		 charCount;

	/* ̌vZ */
	charCount = (length >> 1);
	PUSH_Q( charCount, 0 );
}

PRIVATE void
    u_mojisu( void )		/* ;WORD t .S */
{
        /* (strinfo  count) */

		size_t		 length;
		UCHAR		*string;

	POP_length_and_string;
	u_mojisu_0( length, string );
}



/*-----------------------------------------------------------------------------
                             t[ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_satanMoji( void )		/* ;WORD t[ .S */
{
        /* (strinfo  uchr16) */

		size_t		 length;
		UCHAR		*string;

	/* --------------------------------------------------------- */
	/* :2ker3.c ɂur[vƂ͋pȂ(̈) */
	/* --------------------------------------------------------- */

	POP_length_and_string;
        PUSH_0_AND_RETURN_IF( length < 2 )	/* Ȃ0pushĖ߂ */
	PUSH_1ST_CHAR_UCS2;
}



/*-----------------------------------------------------------------------------
                              tE[ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_utanMoji( void )		/* ;WORD tE[ .S */
{
        /* (strinfo  uchr16) */

		size_t		 length;
		UCHAR		*strNext;

	/* --------------------------------------------------------- */
	/* :2ker3.c ɂurE[vƂ͋pȂ(̈) */
	/* --------------------------------------------------------- */

	POP_length_and_strNext;
	PUSH_0_AND_RETURN_IF( length < 2 )	/* Ȃ0pushĖ߂ */
	PUSH_LAST_CHAR_UCS2;
}



/*-----------------------------------------------------------------------------
                           twʒu̕ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void				/* ߒl: */
    u_siteiItiNoMoji_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string,	/* 2:AhX */
		size_t		 charPos	/* 3:ʒu   */
	            )
{
        /* (.  uchr16) */

		size_t		 bytes;

	PUSH_0_AND_RETURN_IF(length < 2 || charPos == 0)

	bytes = u_countMojisu( length, (charPos - 1) );
	string += bytes;			/* ړIO܂ō폜 */
	length -= bytes;

        PUSH_0_AND_RETURN_IF( length < 2 ) 	/* 폜2oCgɖȂȂ0Ԃ */
        PUSH_1ST_CHAR_UCS2;			/* 擪push */
}

PRIVATE void
    u_siteiItiNoMoji( void )	    /* ;WORD twʒu̕ SN */
{
        /* (strinfo, ʒu  uchr16) */

		size_t		 length;
		UCHAR		*string;
		size_t		 charPos;

	charPos = POP_U_OF_Q;			/* wʒupop */
	POP_length_and_string;			/* pop */
	u_siteiItiNoMoji_0( length, string, charPos );
}



/*-----------------------------------------------------------------------------
                         tEwʒu̕ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void				/* ߒl: */
    u_migiSiteiItiNoMoji_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*strNext,	/* 2:NEXTAhX */
		size_t		 charPos	/* 3:ʒu   */
		        )
{
        /* (.  uchr16) */

		size_t		 bytes;

	PUSH_0_AND_RETURN_IF(length < 2 || charPos == 0)

	bytes = u_countMojisu( length, (charPos - 1) );
	strNext -= bytes;			/* ړI̐폜 */
	length  -= bytes;

        PUSH_0_AND_RETURN_IF( length < 2 ) 	/* 폜2oCgɖȂȂ0Ԃ */
        PUSH_LAST_CHAR_UCS2;			/* push */
}

PRIVATE void
    u_migiSiteiItiNoMoji( void )	    /* ;WORD tEwʒu̕ SN */
{
        /* (strinfo, ʒu  uchr16) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 charPos;

	charPos = POP_U_OF_Q;			/* wʒupop */
	POP_length_and_strNext;			/* pop */
	u_migiSiteiItiNoMoji_0( length, strNext, charPos );
}



/*-----------------------------------------------------------------------------
                            to (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_toridasi_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*string,	/* 2:AhX */
		size_t		 reqChars	/* 3:v */
	      )
{
        /* (.  strinfo) */

		size_t		bytes;

	/* oCǧvZ */
	bytes = u_countMojisu( length, reqChars );
	PUSH_S( string, bytes );
}

PRIVATE void
    u_toridasi( void )		/* ;WORD to SN  :NX */
{
        /* (strinfo,   strinfo) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;			/* pop */
	POP_length_and_string;			/* pop */
	u_toridasi_0( length, string, reqChars );
}



/*-----------------------------------------------------------------------------
                           tEo (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void			/* ߒl: */
    u_migiToridasi_0(
		size_t		 length,	/* 1:񒷂 */
		UCHAR		*strNext,	/* 2:AhX */
		size_t		 reqChars	/* 3:v */
	          )
{
        /* (.  strinfo) */

		size_t		bytes;

	bytes = u_countMojisu( length, reqChars );
	PUSH_S( (strNext - bytes), bytes );
}

PRIVATE void
    u_migiToridasi( void )	/* ;WORD tEo SN  :NX */
{
        /* (strinfo,   strinfo) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;			/* pop */
	POP_length_and_strNext;			/* pop */
	u_migiToridasi_0( length, strNext, reqChars );
}



/*-----------------------------------------------------------------------------
                          tꕶ (Unicode)
-----------------------------------------------------------------------------*/

static ULONG  WordScan(USHORT *address, ULONG count, USHORT key)
{
        /*--------------------------------------------------------------------------*/
        /*  ֐:     WordScan                                                    */
        /*  @\  :     nUSHORT^obt@bufkeyÄʒuԂ   */
        /*  쐬  : 00/01/07                                                        */
        /*  input : USHORT *address...obt@擪AhX                          */
        /*          ULONG   count.....obt@̘_(QoCgłP)        */
        /*          USHORT  key...f[^                                    */
        /*  ret   : ULONG   ret...ʒu(1琔)                             */
	/*                                                                          */
        /*  !!: Little EndianUnicodezړIŎgȂA        */
	/*          key̒l͏㉺oCgt]Ăn.                    */
	/*          (ȂȂA[vł̔zQƂ *address gĂ邽     */
	/*           x86nł͔z񂩂̗vfo㉺oCgtɂȂ邩)       */
        /*--------------------------------------------------------------------------*/

		ULONG	pos;

	for( pos=1; count; count--,pos++ )
	{
		if ( *address++ == key )
		{
			return pos;
		}
	}
	return 0;
}

#if 0
static	ULONG	LongScan(ULONG *address, ULONG count, ULONG key)
{
        /*--------------------------------------------------------------------------*/
        /*  ֐:     LongScan                                                    */
        /*  @\  :     nULONG^obt@bufkeyÄʒuԂ    */
        /*  쐬  : 00/01/07                                                        */
        /*  input : ULONG  *address...obt@擪AhX                          */
        /*          ULONG   count.....obt@̘_(QoCgłP)        */
        /*          ULONG   key...f[^                                    */
        /*  ret   : ULONG   ret...ʒu(1琔)                             */
        /*--------------------------------------------------------------------------*/

		ULONG	pos;

	for( pos=1; count; count--,pos++ )
	{
		if ( *address++ == key )
		{
			return pos;
		}
	}
	return 0;
}
#endif

/* --------------------------- */

PRIVATE void
    u_itiMojiKensaku( void )	    /* ;WORD tꕶ SN */
{
        /* (strinfo, uchr16  ʒu) */

		size_t		 length;
		UCHAR		*string;
		USHORT		 targChar;
		size_t		 pos;

	targChar = POP_U_OF_Q;		/* pop */

	POP_length_and_string;		/* 팟pop */
	length >>= 1;			/* length_ɕϊ */

	if ( IamBigEndian != UCS2_BE )
	{
		/* CPUGfBAUCS2GfBAقȂȂ㉺oCg */
		targChar = (USHORT)(targChar>>8|targChar<<8);
	}

	pos = WordScan( (USHORT *)string, length, targChar );

	PUSH_Q( pos, 0 );
}



/*-----------------------------------------------------------------------------
                                t (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_kensaku_0(
		size_t		 orgChars,	/* 1:Ώۘ_ */
		USHORT		*org,		/* 2:ΏۃAhX(16bitz bigEndian) */
		size_t		 keyChars,	/* 3:L[_ */
		USHORT		*key		/* 4:L[AhX(16bitz bigEndian) */
             )
{
        /* (.  ʒu) */

		USHORT		 keyChar;
		int		 foundKeyChar;
		int		 charIndex;
		int		 foundall;
		int		 foundpos;

	PUSH_0_AND_RETURN_IF( orgChars==0 || keyChars==0 )

	charIndex = 0;				/* ʒȕl=0 */
	foundall = 0;
	keyChar = key[0];

	for(;;)
	{
		/* key̐擪ɓ{ */
		foundKeyChar = 0;
		while( orgChars >= keyChars )
		{
			/* org̐擪key̐擪ɓ */
			if ( org[charIndex] == keyChar )
			{
				foundKeyChar = 1;
				break;
			}
		        orgChars--;
			charIndex++;
		}

		/* 擪ׂ */
		if ( foundKeyChar == 0)		/* 擪H */
		{
			foundpos = 0;		/* ʒu̓[Ƃ */
			break;			/* 擪Ύs */
		}

		/* 擪L聨Ŝ̈v𒲂ׂ */
		/* (org|C^͂܂擪̈ʒuɂ)*/ /*oCgɊZ*/
		if ( memcmp( (void *)&org[charIndex], (void *)key, (keyChars*2) ) == 0 )
		{
			/* Sv */
			foundpos = charIndex+1;		/* 1琔ʒuɕϊ */

			orgChars  -= keyChars;		/* v̕ */
			charIndex += keyChars;		/* ṽCfbNX */

			OrgRemain    = (UCHAR *)&org[charIndex];  /* ޔ */
			LengthRemain = (orgChars * 2);		  /* ޔ */

			break;
		}

		/* ƂĂ͈vȂ擪XLbv */
		orgChars--;
		charIndex++;
	}
	PUSH_Q( foundpos, 0 );
}


PRIVATE void
    u_kensaku( void )		/* ;WORD t SS */
{
        /* (orginfo, keyinfo  ʒu) */

		size_t		 orgChars;
		USHORT		*org;
		size_t		 keyChars;
		USHORT		*key;

	keyChars = POP_C;
	key      = (USHORT *)POP_A;
	orgChars = POP_C;
	org      = (USHORT *)POP_A;

	keyChars >>= 1;	/* _𓾂 */
	orgChars >>= 1;	/* _𓾂 */

	u_kensaku_0( orgChars, org, keyChars, key );
}



/*-----------------------------------------------------------------------------
                   trꕶ폜^trꕶE폜 (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_itiMojiSakujyo( void )		/* ;WORD trꕶ폜 */
{
        /* (strinfo  strinfo) */

		size_t		 length;
		UCHAR		*string;

	READ_length_and_string;				/* 擾 */
	u_itiMojiSakujyo_0( length, string, (ULONG *)TOS );	/* 2ker2.cŒ` */
}

PRIVATE void
    u_S_itiMojiMigiSakujyo( void )	/* ;WORD trꕶE폜 */
{
        /* (strinfo  strinfo) */

		size_t		 length;
		UCHAR		*strNext;

	READ_length_and_strNext;			/* 擾 */
	u_itiMojiMigiSakujyo_0( length, strNext, (ULONG *)TOS );	/* 2ker2.cŒ` */
}



/*-----------------------------------------------------------------------------
               trꕶ؂o^trꕶE؂o (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_itiMojiKiridasi( void )	    /* ;WORD trꕶ؂o */
{
        /* (strinfo  strinfo, uchr16) */

		size_t		 length;
		UCHAR		*string;

	READ_length_and_string;				/* 擾 */
	u_itiMojiKiridasi_0( length, string, (ULONG *)TOS );	/* 2ker2.cŒ` */
}

PRIVATE void
    u_S_itiMojiMigiKiridasi( void )   /* ;WORD trꕶE؂o */
{
        /* (strinfo  strinfo, uchr16) */

		size_t		 length;
		UCHAR		*strNext;

	READ_length_and_strNext;			/* 擾 */
	u_itiMojiMigiKiridasi_0( length, strNext, (ULONG *)TOS );	/* 2ker2.cŒ` */
}



/*-----------------------------------------------------------------------------
                     tr؂o^trE؂o (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_kiridasi( void )		/* ;WORD tr؂o */
{
        /* (strinfo,   strinfo, ) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;				/* vpop */
	READ_length_and_string;				/* 擾 */
	u_kiridasi_Left_0( length, string, (ULONG *)TOS, reqChars );
							/* 2ker2.cŒ` */
}

PRIVATE void
    u_S_migiKiridasi( void )		/* ;WORD trE؂o */
{
        /* (strinfo,   strinfo, ) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;				/* vpop */
	READ_length_and_strNext;			/* 擾 */
	u_kiridasi_Right_0( length, strNext, (ULONG *)TOS, reqChars );
							/* 2ker2.cŒ` */
}



/*-----------------------------------------------------------------------------
                              trf (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_bundan( void )		/* ;WORD trf */
{
	/* (strinfo, ʒu  strinfo, ) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqPos;

	reqPos = POP_U_OF_Q;				/* ʒupop */
	READ_length_and_string;				/* 擾 */
	u_bundan_0( length, string, (ULONG *)TOS, reqPos );
}



/*-----------------------------------------------------------------------------
                        tr폜^trE폜 (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_sakujyo( void )		/* ;WORD tr폜 */
{
        /* (strinfo,   strinfo) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;				/* vpop */
	READ_length_and_string;				/* 擾 */
	u_sakujyo_Left_0( length, string, (ULONG *)TOS, reqChars );   /* 2ker2.cŒ` */
}

PRIVATE void
    u_S_migiSakujyo( void )		/* ;WORD trE폜 */
{
        /* (strinfo,   strinfo) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;				/* vpop */
	READ_length_and_strNext;			/* 擾 */
	u_sakujyo_Right_0( length, strNext, (ULONG *)TOS, reqChars ); /* 2ker2.cŒ` */
}



/*-----------------------------------------------------------------------------
                       tr[^trE[ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_satanMoji( void )		/* ;WORD tr[ */
{
        /* (strinfo  strinfo, uchr16) */

		size_t		 length;
		UCHAR		*string;

	/* ------------------------------------------------------- */
	/* :2ker2.c ɂu[vƂ͋pȂ(̈) */
	/* ------------------------------------------------------- */

	READ_length_and_string;				/* 擾 */
        PUSH_0_AND_RETURN_IF( length < 2 )	/* Ȃ0pushĖ߂ */
	PUSH_1ST_CHAR_UCS2;
}

PRIVATE void
    u_S_utanMoji( void )		/* ;WORD trE[ */
{
        /* (strinfo  strinfo, uchr16) */

		size_t		 length;
		UCHAR		*strNext;

	/* ------------------------------------------------------- */
	/* :2ker2.c ɂuE[vƂ͋pȂ(̈) */
	/* ------------------------------------------------------- */

	READ_length_and_strNext;			/* 擾 */
	PUSH_0_AND_RETURN_IF( length < 2 )	/* Ȃ0pushĖ߂ */
	PUSH_LAST_CHAR_UCS2;
}



/*-----------------------------------------------------------------------------
             trwʒu̕^trEwʒu̕ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_siteiItiNoMoji( void )	/* ;WORD trwʒu̕ */
{
        /* (strinfo, ʒu  strinfo, uchr16) */

		size_t		 length;
		UCHAR		*string;
		size_t		 charPos;

	charPos = POP_U_OF_Q;				/* wʒupop */
	READ_length_and_string;				/* 擾 */
	u_siteiItiNoMoji_0( length, string, charPos );    /* 2ker2.cŒ` */
}

PRIVATE void
    u_S_migiSiteiItiNoMoji( void )	/* ;WORD trEwʒu̕ */
{
        /* (strinfo, ʒu  uchr16) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 charPos;

	charPos = POP_U_OF_Q;				/* wʒupop */
	READ_length_and_strNext;			/* 擾 */
	u_migiSiteiItiNoMoji_0( length, strNext, charPos );  /* 2ker2.cŒ` */
}



/*-----------------------------------------------------------------------------
                     tro^trEo (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_toridasi( void )			/* ;WORD tro */
{
        /* (strinfo,   strinfo, ) */

		size_t		 length;
		UCHAR		*string;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;				/* vpop */
	READ_length_and_string;				/* 擾 */
	u_toridasi_0( length, string, reqChars );		/* 2ker2.cŒ` */
}

PRIVATE void
    u_S_migiToridasi( void )		/* ;WORD trEo */
{
        /* (strinfo,   strinfo, ) */

		size_t		 length;
		UCHAR		*strNext;
		size_t		 reqChars;

	reqChars = POP_U_OF_Q;				/* vpop */
	READ_length_and_strNext;			/* 擾 */
	u_migiToridasi_0( length, strNext, reqChars );	/* 2ker2.cŒ` */
}



/*-----------------------------------------------------------------------------
                       tr^rꕶ (Unicode)
-----------------------------------------------------------------------------*/

PRIVATE void
    u_S_itiMojiKensaku( void )	/* ;WORD trꕶ */
{
        /* (strinfo, uchr16  strinfo, ʒu) */

		size_t		 length;
		UCHAR		*string;
		USHORT		 targChar;
		size_t		 pos;

	targChar = POP_U_OF_Q;		/* pop */

	READ_length_and_string;		/* 팟񕡎 */
	length >>= 1;			/* length_ɕϊ */

	if ( IamBigEndian != UCS2_BE )
	{
		/* CPUGfBAUCS2GfBAقȂȂ㉺oCg */
		targChar = (USHORT)(targChar>>8|targChar<<8);
	}

	pos = WordScan( (USHORT *)string, length, targChar );

	PUSH_Q( pos, 0 );
}

PRIVATE void
    u_S_kensaku( void )		/* ;WORD tr */
{
        /* (orginfo, keyinfo  orginfo, ʒu) */

		size_t		 orgChars;
		USHORT		*org;
		size_t		 keyChars;
		USHORT		*key;

	keyChars = POP_C;
	key      = (USHORT *)POP_A;
	orgChars = READ_C_OF_S;
	org      = (USHORT *)READ_A_OF_S;

	keyChars >>= 1;		/* _ɕϊ */
	orgChars >>= 1;		/* _ɕϊ */

	u_kensaku_0( orgChars, org, keyChars, key );	/* 2ker2.cŒ` */
}


/* end of '2kerU.c' */
