/*-----------------------------------------------------------------------------
                        R[ȟ(EUCR[hΉ)
-----------------------------------------------------------------------------*/

#define SJIS_CHARACTER 1

#define isThisByteKanji_SJIS(c) \
	( ((c)>=0x81 && (c)<= 0x9f) || (((c)>=0xe0) ? 1 : 0) )

#define isThisByteKanji_EUC(c) \
	( (c & 0x80) != 0 )

#if SJIS_CHARACTER
#define isThisByteKanji(c) isThisByteKanji_SJIS(c)
#else /*EUC*/
#define isThisByteKanji(c) isThisByteKanji_EUC(c)
#endif

#define	isThisCharKanji(c,len) \
	( ((len)<2) ? 0 : isThisByteKanji(c) )


/*-----------------------------------------------------------------------------
                    TclXNvg { }  [ ] ɒu
-----------------------------------------------------------------------------*/

static void
change_delimitor( char *target )
{
		unsigned char	*string;
		int		 length;
		unsigned char	 oneByte;
		unsigned short	 twoBytes;

	string = (unsigned char *)target;
	length = strlen( target );

	while( length )
	{
		oneByte = *string;

		if ( isThisCharKanji(oneByte,length) )
		{
			/* ----- */
			/* KANJI */
			/* ----- */
			twoBytes = (unsigned short)oneByte<<8 | string[1];
			string += 2;
			length -= 2;
		}
		else
		{
			/* ----- */
			/* ASCII */
			/* ----- */
        		if ( oneByte == '{' )
			{
				*string = '[';
			}
        		else if ( oneByte == '}' )
			{
				*string = ']';
			}
			string++;
			length--;
		}
	}
}

