/*===========================================================================*/
/*                                                                           */
/*                    Mind version 7.0 runtime library                       */
/*                                                                           */
/*                 Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*  t@C: dispword.c (kernel.c̃CN[ht@C)                  */
/*  @\      : ^CfobNp̕\nP`                         */
/*  쐬      : Ћ (1994.09.01)                                          */
/*  L        : IWi̓AZuLq('R4'DISPWORD.ASM)               */
/*---------------------------------------------------------------------------*/


/* L^ -/

1992.03.10    	QUEEN4ׂ̈ɐVK쐬B

1992.04.06    	$$ꕶ\ǉB

1992.06.09    	u\vȂǂ̒`ubNAuMONITOR_INCLUDEv̏A
              	Zu悤ɂB

1995.04.12	'rR'̂߂bŏ.

1995.08.24	uX^bN_vvсu|[Yv`D

1996.03.03	RpC'DISPWORD_INCLUDE'kernel.c̓ł͂ȂA
		Ɉړimaktblł悤ɂ邽߁j

/- I */

/*PAGE*/
/*-----------------------------------------------------------------------------
                                    \n
-----------------------------------------------------------------------------*/

#if  DISPWORD_INCLUDE		/* kernel.defŒ` */

PRIVATE void
    printChar(
    		CHAR c
    	     )
{
	fputc ( c , stdout);
}

PRIVATE void
    printStrinf(
    		UCHAR  *addr,
    		size_t  size
    	       )
{
	fwrite( (void *)addr, size, 1, stdout );
}

PRIVATE void
    printNibble(
    		UCHAR	n
    	       )
{
	n = n & 0x0f;
	/* ----------------------------------- */
	/* ȂL̂悤ɂȂ"01X"w */
	/* ɂ炸Q\Ă܂D*/
	/* ----------------------------------- */
	printf( "%01X", n );
}

PRIVATE void
    printByte(
    		UCHAR	n
    	     )
{
	printf( "%02X", n );
}

PRIVATE void
    printWord(
    		USHORT	n
    	     )
{
	printf( "%04X", n );
}

PRIVATE void
    printDouble(
    		ULONG	n
    	       )
{
	printf( "%08lX", n );
}

PRIVATE void
    printFloat(
    		double f
    	       )
{
	printf("%f\n", f);
}

#if 0
PRIVATE void
    printQuad(
    		word64 n
    	       )
{
		ULONG	hi;
		ULONG	lo;

	hi = n >> 32;
	lo = n & 0xffff;
	printf("%08lx|%08lx", hi, lo);
}
#endif

/*PAGE*/

PRIVATE void
    zzHyouji( void )                	/* ;WORD \ */
{
		ULONG	count;
		UCHAR  *addr;
		
	/* (strinf  .) */

	count = POP_C;
	addr  = POP_A;
	printStrinf( addr, count );
}

PRIVATE void
    zzDoubleQuateHyouji( void )      /* ;WORD $$_uNI[gň͂ŕ\ */
{
	/* (strinf  .) */

	printChar( '"' );
	zzHyouji();
	printChar( '"' );
}

PRIVATE void
    zzIchimojiHyouji( void )		/* ;WORD ꕶ\ */
{
		USHORT	wideChar;

	/* (widechar  .) */

	wideChar = POP_W_OF_Q;
	if ( wideChar > 255 )
	{
		printChar( wideChar >> 8 );
		printChar( wideChar & 0xff );
	}
	else
	{
		printChar( wideChar );
	}
}

PRIVATE void
    zzKaigyou( void )			/* ;WORD s */
{
	/* (.  .) */

        printf ( "\n" );
}

/*PAGE*/

PRIVATE void
    zzNibbleHyouji( void )		/* ;WORD ju\ */
{
		UCHAR	value;
		
	/* (value  .) */

	value = POP_B_OF_Q;
	printNibble( value ); 
}

PRIVATE void
    zzByteHyouji( void )		/* ;WORD oCg\ */
{
		UCHAR	value;
		
        /* (value  .) */
		
	value = POP_B_OF_Q;
	printByte( value ); 
}

PRIVATE void
    zzWordHyouji( void )		/* ;WORD [h\ */
{
		USHORT	value;
		
        /* (value  .) */
		
	value = POP_W_OF_Q;
	printWord( value ); 
}

PRIVATE void
    zzDoubleHyouji( void )		/* ;WORD _u\ */
{
		ULONG	value;
		
        /* (value  .) */

	value = POP_U_OF_Q;
	printDouble( value );
}

/*PAGE*/


/* -------------------------- {xΉ ------------------------ */
/*                                                                        */
/*                                                                        */
PRIVATE void
    zzBaiseidoHyouji( void )		/* ;WORD {x\ */
{
		word64	qval;

        /* (quad  .) */

	qval = pop_quad();
	printf("%lld", qval);
}

#if 0
PRIVATE void
    zzQuadHyouji( void )		/* ;WORD NAh\ */
{
		long long unsigned int	qval;
		ULONG	hi;
		ULONG	lo;

        /* (quad  .) */

	qval = pop_quad();
	printQuad( qval );
}
#endif

/* -------------- */

PRIVATE void
    c_conv_to_string_quad( void )		/* ;WORD c_conv_to_string_quad */
{
	/* (quadAi[  string) */

		word64	 	 qval;
		int		 mvarlen;
		tGeneralPointer  varAddr;
		const char	*cvalueStr;
		int		 cvalueStrLen;


	/* ̏POP */
	mvarlen   = POP_U;
	varAddr.b = POP_A;
	varAddr.u[0] = 0;		/*̂NA*/
	varAddr.u[1] = 0;		/*̂NA*/
	cvalueStr = (UCHAR *)&(varAddr.u[2]);

	/* quadlPOP */
	qval = pop_quad();

	sprintf( cvalueStr, "%lld", qval );

	cvalueStrLen = strlen( cvalueStr );
	varAddr.u[0] = cvalueStrLen;

	PUSH_A( cvalueStr );		/* push address */
	PUSH_C( cvalueStrLen );		/* push length  */
}

/*                                                                        */
/*                                                                        */
/*                                                                        */
/* -------------------------- {xΉ܂ ------------------------ */



/* --------------------------- Ή ------------------------- */
/*                                                                        */
/*                                                                        */
PRIVATE void
    zzSyosuHyouji( void )		/* ;WORD `ŕ\ */
{
		double	fval;
		ULONG	keta;

        /* (floatA  .) */

	keta = POP_U_OF_Q;
	fval = pop_float();
	printf("%.*f", keta, fval);
}

PRIVATE void
    zzSisuHyouji( void )		/* ;WORD w`ŕ\ */
{
		double	fval;
		ULONG	keta;

        /* (floatA  .) */

	keta = POP_U_OF_Q;
	fval = pop_float();
	printf("%.*e", keta, fval);
}

/* -------------- */

PRIVATE void
    c_conv_to_string_fraction( void )		/* ;WORD c_conv_to_string_fraction */
{
	/* (floatASAAi[́Aw`  string) */

		double		 fval;
		ULONG		 allketa;
		ULONG		 fraketa;
		ULONG		 expform;
		int		 mvarlen;
		tGeneralPointer  varAddr;
		const char	*cvalueStr;
		char		*strbuffer;
		int		 cvalueStrLen;


	/* w`POP */
	expform = POP_U_OF_Q;

	/* ̏POP */
	mvarlen   = POP_U;
	varAddr.b = POP_A;
	varAddr.u[0] = 0;		/*̂NA*/
	varAddr.u[1] = 0;		/*̂NA*/
	cvalueStr = (UCHAR *)&(varAddr.u[2]);
	strbuffer = (UCHAR *)&(varAddr.u[2]);

	/* cPOP */
	fraketa = POP_U_OF_Q;
	allketa = POP_U_OF_Q;
	fval = pop_float();

	if ( expform )
	{
		if ( allketa == 0 )
		{
		    #if DOS_ENVIRONMENT
			_snprintf( cvalueStr, mvarlen, "%.*e", fraketa, fval );
		    #else
			snprintf( cvalueStr, mvarlen, "%.*e", fraketa, fval );
		    #endif
		}
		else
		{
		    #if DOS_ENVIRONMENT
			_snprintf( cvalueStr, mvarlen, "%*.*e", allketa, fraketa, fval );
		    #else
			snprintf( cvalueStr, mvarlen, "%*.*e", allketa, fraketa, fval );
		    #endif
		}
	}
	else
	{
		if ( allketa == 0 )
		{
		    #if DOS_ENVIRONMENT
			_snprintf( cvalueStr, mvarlen, "%.*f", fraketa, fval );
		    #else
			snprintf( cvalueStr, mvarlen, "%.*f", fraketa, fval );
		    #endif
		}
		else
		{
		    #if DOS_ENVIRONMENT
			_snprintf( cvalueStr, mvarlen, "%*.*f", allketa, fraketa, fval );
		    #else
			snprintf( cvalueStr, mvarlen, "%*.*f", allketa, fraketa, fval );
		    #endif
		}
	}
	strbuffer[mvarlen - 1] = 0;
	cvalueStrLen = strlen( cvalueStr );
	varAddr.u[0] = cvalueStrLen;

	PUSH_A( cvalueStr );		/* push address */
	PUSH_C( cvalueStrLen );		/* push length  */
}

/*                                                                        */
/*                                                                        */
/*                                                                        */
/* --------------------------- Ή܂ ------------------------- */



PRIVATE void
    zzQuadHyouji( void )		/* ;WORD NAh\ */
{
		ULONG	integer;
		ULONG   fraction;
		
        /* (value  .) */

	fraction = POP_F;
	integer  = POP_L;
	printDouble( integer );
	printf( "|" );
	printDouble( fraction );
}

/*PAGE*/

PRIVATE void
    zzDump( void )			/* ;WORD _v */
{
		ULONG	count;
		UCHAR  *addr;
		USHORT  oneSize;
		
	/* (address, size  .) */
        
	count = POP_U_OF_Q;
	addr  = (UCHAR *)POP_U_OF_Q;

	do
	{
		oneSize = min( count, 16 );
		count -= oneSize;
		printf( "%08lX :", addr );
		while( oneSize )
		{
			printf( " %02X", *addr++ );
			oneSize--;
		}
		printf( "\n" );
	}while( count );
}

PRIVATE void
    zzDumpWord( void )			/* ;WORD _vE[h */
{
		ULONG	count;
		USHORT *addr;
		USHORT  oneSize;
		
	/* (address, size  .) */
        
	count = POP_U_OF_Q;
	count = (count + 1) & 0xfffffffeL;	/* JEg */
	addr  = (USHORT *)POP_U_OF_Q;

	do
	{
		oneSize = min( count, 16 );
		count -= oneSize;
		printf( "%08lX :", addr );
		while( oneSize )
		{
			printf( " %04X", *addr++ );
			oneSize -= 2;
		}
		printf( "\n" );
	}while( count );
}

/*PAGE*/
/*-----------------------------------------------------------------------------
                                 X^bN_v
-----------------------------------------------------------------------------*/

PRIVATE void
    yokosen( void )
{
	printf( "-------------------------------------------------------\n" );
}

PRIVATE void
    zzStackDump( void )		/* ;WORD X^bN_v */
{
		ULONG            sp;
		ULONG            spBase;
		ULONG           *addr;
		USHORT           count;
		
	/* (data1, data2, ... dataN  .) */
        /*                     sp       */

	/* ---------------------------------------------- */
	/* Ff[^X^bN͖߂鎞ɃZbgĂ */
	/* ---------------------------------------------- */

        stackPointer();			/* X^bN|C^+x[XAhX */
        spBase = POP_L;
        sp     = POP_L;

	yokosen();
	printf( "sp=%08lX base=%08lX\n", sp, spBase );
	
        if ( sp > spBase )
        {
        	printf( "X^bNA_[t[Ă܂D\n" );
		yokosen();
                resetDataStackPointer();
		return;
        }
        
        if ( (spBase - sp) & 7L )
        {
        	printf( "X^bN|C^ُłD\n" );
		yokosen();
                resetDataStackPointer();
		return;
        }
        
	count = (spBase - sp)/8;
	addr  = (ULONG *)spBase;

	printf( "X^bNeF " );
	while( count )
	{
		addr -= 2;
		printf( "%08lX|%08lX  ", addr[1], addr[0] );
		count--;
	}
        printf( "\n" );
	yokosen();

        resetDataStackPointer();
}

/*PAGE*/

PRIVATE void
    zzReturnStackMonitor( void )	/* ;WORD ^[X^bNj^ */
{
	printf( "ReturnStackPointer=%08lX (base=%08lX)\n",
	                    RstackPointer, RetnStackBase );
}

#endif  	/* DISPWORD_INCLUDE */


/* end of 'dispword.c' */
