/*===========================================================================*/
/*                                                                           */
/*                    Mind version 7.0 runtime library                       */
/*                                                                           */
/*                 Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*  t@C: exec.c                                                       */
/*  @\      : Win32LN^[h̃AvP[Ṽ`            */
/*  쐬      : Ћ (1998.01.11)                                          */
/*---------------------------------------------------------------------------*/

/* L^ -/
1998.01.11      VK쐬.
/- I */


/*PAGE*/
/*----------------------------------------------------------------------------
                               IMPORT HEADER FILES
----------------------------------------------------------------------------*/

#include <stdio.h>
#include <sys\types.h>
#include <stdlib.h>		/* atoi(), atol(), _psp, min(), max() */
#include <string.h>
#include <errno.h>

#include "osdefine.def"
#include "common.def"

#include <io.h>			/* for write() */
#include <direct.h>		/* for getcwd() */
#include <sys\stat.h>
#include <fcntl.h>
#include <process.h>

/*PAGE*/
/*----------------------------------------------------------------------------
                                  i
----------------------------------------------------------------------------*/

PRIVATE char    *Argv[2000];        	/* exec()np */
PRIVATE char    *ProgramName;


/*PAGE*/
/*----------------------------------------------------------------------------
                                  C
----------------------------------------------------------------------------*/

int main(int argc, char **argv)
{
                int	    i;
		char	   *buff;

	if ( argc < 2 )
	{
		printf("no program name\n");
		exit(1);
	}
	ProgramName = argv[1];
	Argv[0] = ProgramName;

#if 0							/*TEST*/
	printf("argc=%d ProgramName=%s\n",argc, ProgramName);
	for (i=0;i<argc;i++)
	{
		printf("arg%d=[%s]\n",i,argv[i]);
	}
#endif

	for( i=2; i<argc; i++ )
	{
/*		printf("arg%d=[%s]\n",i,argv[i]);	TEST*/
		if ( strchr(argv[i],' ') )
		{
			buff = malloc( strlen(argv[i]) + 3 );
			if ( buff == NULL )
			{
				printf( "No memory for arg buffer\n" );
				exit(1);
			}
			strcpy( buff, "\"" );
			strcat( buff, argv[i] );
			strcat( buff, "\"" );
		Argv[i-1] = buff;
		}
		else
		{
		        Argv[i-1] = argv[i];
		}
	}
	Argv[argc] = NULL;

#if 0	/*TEST*/
	for (i=0;i<argc;i++)
	{
		printf("Arg%d=[%s]\n",i,Argv[i]);
	}
#endif

	{
			int	retcode;
			int	is_cgi;
			int	length;
			char	*s;

		is_cgi = 0;
		length = strlen( ProgramName );
		if ( length > 4 )
		{
			s = &ProgramName[length-4];
			if ( strcmp(s,".CGI") == 0 || strcmp(s,".cgi") == 0 )
			{
				is_cgi = 1;
			}
		}

		if ( !is_cgi )
		{
			printf(".cgiłȂvON悤Ƃ܂\n");
			exit(1);
		}

		/* printf("try exec '%s'\n",ProgramName);   	TEST*/

		/* -------------------------------------------------------- */
		/* DOS̏ꍇexit()gƐeɐiނ̂spawn()ɂ */
		/* -------------------------------------------------------- */
		retcode = spawnv( P_WAIT, ProgramName, &(Argv[0]) );
		if ( retcode != -1 )
		{
			exit(retcode);	      /* q̏IR[hɕԂ */
		}
        
		printf( "No program\n" );
		exit(1);
	}
}


/* end */
