/* L^ -/
1999.09.04	strcmpNocase()̃oO𒼂
/- I */


                    /* ---------------------------- */
                    /* ɂ֐ׂ͂static */
                    /* ---------------------------- */

static int		/* Fkermain.cɂ̂ */
strcmpNocase( char *dest, char *source )
{
		char	c1;
		char	c2;

	while(1)
	{
		c1 = *dest++;
		c2 = *source++;
		c1 = toupper( c1 );
		c2 = toupper( c2 );
		if ( c1==0 && c2==0 )
		{
			return 0;
		}
		if ( c1 < c2 )
		{
			return -1;
		}
		if ( c1 > c2 )
		{
			return 1;
		}
	}
}

/* ---- */

    #if DOS_ENVIRONMENT

#define isThisByteKanji(c) \
    ( ((c)>=0x81 && (c)<= 0x9f) || (((c)>=0xe0) ? 1 : 0) )
#define	passSeparator 92			/* '\' */

    #else /*UNIX*/

#define isThisByteKanji(c) \
    ( (c & 0x80) != 0 )
#define	passSeparator '/'			/* '/' */

    #endif


#define isThisCharKanji(c,len) \
    ( ((len)<2) ? 0 : isThisByteKanji(c) )

typedef unsigned char uchar;

/* ---- */

static int	/* ߒl:0or1 */
isLastCharKanji(
		uchar  *s,		/* 1:NEXTAhX */
		int	length		/* 2:         */
	       )
{
		uchar	c;
		int	kanjiCounter;

	s -= 2;					/* s=̉E[-1oCg */
	kanjiCounter = 0;			/* JE^NA */

	while( length >= 2)
	{
		c = *s--;			/* c=2oCg   */
		if ( isThisByteKanji(c) )	/* ͊oCg? */
		{

			length--;		/* 񒷂1oCgk  */
			kanjiCounter++;		/* JE^ */
		}
		else
		{
			break;
		}
	}
	return (kanjiCounter & 1);		/* JE^Ȃ */
}						/* ^ԂD             */

/* -- */

static int	/* ߒl:Zk */
count_length_for_limit( char *string , int length , int limit )
{
		int	oneOrTwo;
		int	shortedlength;

	shortedlength = 0;
	for(; length ; )
	{
		oneOrTwo = isThisCharKanji( *string, length ) + 1;
		if ( (shortedlength + oneOrTwo) > limit )
		{
			break;              /* ߂Ȃ炱ŏI */
		}
		string += oneOrTwo;
		length -= oneOrTwo;
		shortedlength += oneOrTwo;
	}
	return shortedlength;
}


static int	/* ߒl:t@C */
get_purename_length( char *string , int length )
{
		int	oneOrTwo;
		int	purelength;
		uchar	lastchar;

	string += length;		/* string=NEXT */
	purelength = 0;

	for( ; length ; )
	{
		oneOrTwo = isLastCharKanji( (uchar *)string, length ) + 1;
		if ( oneOrTwo == 1 )
		{	/* ANK */
			lastchar = *(string-1);
			if ( lastchar == ':' || lastchar == passSeparator )
			{
				break;
			}
		}
		string -= oneOrTwo;
		length -= oneOrTwo;
		purelength += oneOrTwo;
	}
	return purelength;
}


static int	/* ߒl:gq */
get_ext_length( char *string , int length )
{
		int	oneOrTwo;
		int	extlength;	/* F'.'܂ */
		int	found;
		uchar	lastchar;

	string += length;		/* string=NEXT */
	extlength = 0;
	found = 0;

	for( ; length ; )
	{
		oneOrTwo = isLastCharKanji( (uchar *)string, length ) + 1;
		if ( oneOrTwo == 1 )
		{	/* ANK */
			lastchar = *(string-1);
			if ( lastchar == ':' || lastchar == passSeparator )
			{
				break;
			}
			if ( lastchar == '.' )
			{
				extlength++;
				found = 1;
				break;
			}
		}
		string -= oneOrTwo;
		length -= oneOrTwo;
		extlength += oneOrTwo;
	}
	if ( found )
	{
		return extlength;
	}
	else
	{
		return 0;
	}
}

static void
reject_ext( char *myname )
{
		int	length;
		int	extlength;
		char	*s;

	length = strlen( myname );
	extlength = get_ext_length( myname, length );
	if ( extlength )
	{
		s = myname + length - extlength;
		*s = '\0';		/* '.'ʒuNA */
	}
}

static void
add_mco( char *myname )
{
	strcat( myname, ".mco" );
}

static void
add_mco_if_not( char *myname )
{
		int	length;
		int	extlength;

	length = strlen( myname );
	extlength = get_ext_length( myname, length );
	if ( extlength == 0 )
	{
		/* gq */
		add_mco( myname );
	}
}

/*EOF*/
