/*===========================================================================*/
/*                                                                           */
/*                    Mind version 7.0 runtime library                       */
/*                                                                           */
/*                 Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*  t@C: mindexecw.c                                                  */
/*  @\      : fBXpb`NvO(Win32 GUI)                      */
/*  쐬      : Ћ (1996.03.13)                                          */
/*---------------------------------------------------------------------------*/

/* L^ -/
1996.03.14      VK쐬.
1998.05.03	Win32 GUI pɓƗ
1998.09.01	NpX̒ɔpJiƈُɂȂĂ܂oOC
1998.09.21	GUIłmindexecw.exeł́AAvƓł̗pƂǂ
		ł悤ɂi̂ŒӁj
1998.09.22	R\[ł̂悤ɂB
1998.09.25	mruntXXX.exeNłȂiexecvp^[j
		 bin\, ..\bin, runtime\, ..\runtime ƂpXT
		[`悤ɂB
1998.09.25	WINSILENTΉ
1999.09.04	GUIłemgcyExit()̒winpause()Ȃ悤ɂ
1999.09.04	CGiłemgcyExit()̒emgcyHeaderOutput()Ȃ悤
		ɂ
2000.02.24	GUIł̏ꍇɁAvOi[pXɋ󔒂܂܂ƌ듮
		Ă̂𒼂B
2000.08.27	GUIłłĂTcl/Tk͎gȂ悤ɂB
		(WinSilentWinGUI͂قړɂȂ(ACR_قȂ))
		mrunt̂肩́APATHϐłȂAWXg
		ɂB̊֌WŐVCN[h"try_multipath_exec.c"
		ǉɂȂB
2004.01.22	mind.cgił͂ȂAAvƓmindexecg
		ɂBi: http://localhost/path/application.cgi?argsj
2016.07.01	VPureMindΉ
		- get_registry_runtimePath()iregistrypXQƁj폜
		- UNIXpR[h폜(ǂ݂̂Ⴄ\[XȂ̂)
		- mindexec.exe, mindexecw.exe Ȃǂ̃}b`O
		  Vdlł mindex.exe, mindexw.exe ȂǂɕύXB
		- charset=x-sjis ͌Â\L̂ shift_jis ɒ
/- I */


/*PAGE*/
/*----------------------------------------------------------------------------
                               IMPORT HEADER FILES
----------------------------------------------------------------------------*/

#define RUNTIME_NAME_BASE "mrunt"

#define CON_MONITOR 0	/*TEST*/

#define GUI_OR_DLL GUI	/* DLLmindex.cł͗L蓾Ȃkernel\[X݊̈ */

#if GUI
#define NOT_GUI 0
#else
#define NOT_GUI 1
#endif

#if GUI
#include <windows.h>
#include <stdio.h>	/* for sprintf() */
#include <stdarg.h>
#else
#include <windows.h>
#endif

#include <sys\stat.h>
#include <string.h>
#include <stdlib.h>	/* for atoi(), sprintf() */
#include <process.h>	/* for cwait */

/* === ȉMindƎ̃wb_t@C === */

#include "common.def"

#if GUI
#include "wincons.h"
#endif

#include "osfunc.h"	/* nrC^[tF[XCũwb_t@C */
#include "kernel.def"	/* kernelŎgƎ^` */

#include "filenamehandle.c"

#define PATH_SIZE  512
#define FNAME_SIZE 600

PRIVATE char	McodeFilename[FNAME_SIZE];
PRIVATE char	RuntimeProgname[FNAME_SIZE];
PRIVATE char	VersionDigits[7];
PRIVATE char	ErrorMessage[256];
PRIVATE char    MyPath[PATH_SIZE];
PRIVATE char    MyPurename[PATH_SIZE];
PRIVATE char	FullpathRuntname[PATH_SIZE];

#if GUI
PRIVATE char	*CmdLineRemaining;
PRIVATE char	*NewCmdLine;
#endif

static char	*trypath[]=
	{ ".",
	  "bin", "runtime", "installer", "..",
	  "bin", "runtime", "installer", "..",
	  "bin", "runtime", "END" };

/*PAGE*/
/*-----------------------------------------------------------------------------
                              CGIpً̋}wb_o
-----------------------------------------------------------------------------*/

#if NOT_GUI
#define winprintf printf
/*#define winpause sysPause*/
void exit_program( int status )
{
	exit( status );
}
#endif

#if GUI
void exit_program( int status )
{
	ExitProcess( status );
}
#endif

void emgcyHeaderOutput( void )
{
#if CGI_ENVIRONMENT
	printf( "Content-type: text/html; charset=shift_jis\n\n"
	        "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n"
		"<HTML>\n"
		"<HEAD>\n"
		"<TITLE>Error in Mind runtime</TITLE>\n"
		"</HEAD>\n"
		"<body>\n" );
#endif
#if GUI
	startwinconsole();		/*DLLł͎sĂ͂Ȃ*/
#endif
}

void emgcyExit( void )
{
#if CGI_ENVIRONMENT
	printf( "</body>\n</HTML>\n" );
#endif
#if GUI_OR_DLL
	winpause();
	endwinconsole();
#endif
	exit_program( 1 );
}



/*----------------------------------------------------------------------------
                                  i(1)
----------------------------------------------------------------------------*/

PRIVATE int
  is_top_path( char *path )
{
		int	length;

	/* d:\ Ƃ MACHINE\\ ̏ꍇɐ^Ԃ */
	length = strlen( path );
	if ( length >= 2 && path[length-1] == '\\' )
	{
		/*  \ ł @ɑO𒲂ׂ */
		if ( path[length-2] == ':' || path[length-2] == '\\' )
		{
			return 1;
		}
	}
	return 0;
}

PRIVATE void
  delete_tail_backslash( char *path )
{
		int	length;

	length = strlen( path );
	if ( length >= 1 && path[length-1] == '\\' )
	{
		/*  \ ł @ɑO𒲂ׂ */
		if ( is_top_path(path) == 0 )
		{
			length = strlen( path );
			path[length-1] = 0;
		}
	}
}

PRIVATE void
  save_mypath( void )
{
		int	length;
		int	purelength;
		int	resultLen;
    #if CGI_ENVIRONMENT
		char	*s;
    #endif

 	strcpy( MyPath, McodeFilename );
	length = strlen( MyPath );
	purelength = get_purename_length( MyPath, length );
	resultLen = length - purelength;
    #if CGI_ENVIRONMENT == 0
	MyPath[resultLen] = 0;
	delete_tail_backslash( MyPath );
    #else
	s = McodeFilename + length - purelength;
	strcpy( McodeFilename, s );
	MyPath[0] = 0;
    #endif
}

PRIVATE void
  save_mypurename( char *myname )
{
		int	length;
		int	purelength;
		char	*s;

	length = strlen( myname );
	purelength = get_purename_length( myname, length );

	s = myname + length - purelength;
	strcpy( MyPurename, s );
}

#if GUI		/*   GUI   */
PRIVATE void
  copy_mcode_filename( char *cmdline )
{
		int	i;
		char	*storePoint;
		char	c;

	/* p[^Mcodet@C */
	/* Ȃ̂ŁAޔ  */

	if ( *cmdline == '"' )		/* 擪́u"vO */
	{
		cmdline++;
	}

	/* ------------------------------------------- */
	/* F́u"vMindɓĂO!! */
	/* ------------------------------------------- */

	storePoint = McodeFilename;

	/* 擪McodeFilenameɕ */
	for( i=0;;i++ )
	{
		if ( i >= PATH_SIZE )
		{
			break;
		}
		c = *cmdline;
		if ( c == 0 )
		{
			break;
		}
		if ( c == 0x20 )    /*1998.09.01oOC*/
		{
			cmdline++;
			break;
		}
		cmdline++;
		*storePoint++ = c;
	}

	/* [I[ */
	if ( i && (*(storePoint-1)=='"') )
	{
		*(storePoint-1) = '\0';
	}
	else
	{
		*storePoint = '\0';
	}

	/* CmdLineRemaining ݒ肷 */
	CmdLineRemaining = cmdline;

	/* gq.mcoǉ */
	add_mco_if_not( McodeFilename );
}
#endif		/* GUI */



PRIVATE void				/* ߒl:0= =s */
  make_runtname_and_cmdline( void )
{
		int	length1;
		int	length2;

	/* --------------------------- */
	/* ^CvO      */
	/* --------------------------- */
	strcpy( RuntimeProgname, RUNTIME_NAME_BASE );
	strcat( RuntimeProgname, VersionDigits );
	strcat( RuntimeProgname, ".exe" );
#if GUI
	/* --------------------------- */
	/* MR[hƂ̂Ƃ̈Q */
	/* --------------------------- */
	length1 = strlen( McodeFilename );
	length2 = strlen( CmdLineRemaining );
	NewCmdLine = (char *)malloc( length1 + length2 + 6 );
	if ( NewCmdLine == NULL )
	{
		startwinconsole();
		winprintf( "No memory\n" );
		winpause(); endwinconsole();
		ExitProcess(1);
	}
	strcpy( NewCmdLine, "\"" );
	strcat( NewCmdLine, McodeFilename );
	strcat( NewCmdLine, "\"" );
	strcat( NewCmdLine, " " );
	strcat( NewCmdLine, CmdLineRemaining );
#endif
}

PRIVATE int			        /* ߒl:1=L/0: */
    is_this_file_exist( char *filename )
{
	static struct stat statBuffer;

	return ( stat( filename,&statBuffer) == 0 );  /* 0=success */
}



#include "mindex_readmcode.c"		/* Windows, UNIX ʃ\[X */




/*----------------------------------------------------------------------------
                               C(Console)
----------------------------------------------------------------------------*/

#if NOT_GUI

 	/* -------------------------- */
	/* F ConsoleubN */
 	/* -------------------------- */

int main(int argc, char **argv)
{
                int	    i;
		int	    args;
                tErrcode    retcode;
		char	  **Argv;
		int	    top_arg;
		int	    ArgPtr;

    #if CON_MONITOR
	printf("-entering mindex----\n");
	for (i=0;i<argc;i++)
	{
		printf("arg%d=[%s]\n",i,argv[i]);
	}
	printf("----------------------\n");
    #endif

	/* Ȃ̃tpXvO𓾂 */
	GetModuleFileName(NULL, McodeFilename, sizeof(McodeFilename));

 	/* -------------------------- */
	/* F ConsoleubN */
 	/* -------------------------- */

	save_mypath();
    #if CON_MONITOR
	winprintf("MyProg=%s\n",McodeFilename);
	winprintf("MyPath=%s\n",MyPath);
    #endif
	save_mypurename( McodeFilename );	/* Arg[0]Ŏg  */
    #if CON_MONITOR
	winprintf("MyPure=%s\n",MyPurename);
    #endif

	if ( strcmpNocase(MyPurename,"mindex.exe") == 0 )
	{
	    #if CON_MONITOR      /* argv[0]   argv[1] argv[2`] */
		winprintf("Type: mindex.exe MyApp --args--\n");
	    #endif
		if ( argc < 2 )		/* ŒłMyAppL */
		{
			emgcyHeaderOutput();
			printf( "No Mcode-Filename specified\n" );
			emgcyExit();
		}
		strcpy( McodeFilename, argv[1] );   /* MyApp Rs[  */
		add_mco_if_not( McodeFilename );    /* MyApp.mcoƂ */
		top_arg = 2;
	}
	else
	{
	    #if CON_MONITOR      /* argv[0] argv[1`] */
		winprintf("Type: MyApp.exe args..\n");
	    #endif
		reject_ext( McodeFilename );	    /* .exe O */
		add_mco( McodeFilename );	    /* .mco t */
		top_arg = 1;
	}

    #if CON_MONITOR
	printf("McodeFilename=%s\n",McodeFilename);
	/*sysPause();*/
    #endif

 	/* -------------------------- */
	/* F ConsoleubN */
 	/* -------------------------- */

	args = argc + 2;	/* 炷̂+1,NULLp+1 */
	Argv = (char **)malloc( args * sizeof(char *) );
	Argv[0] = "(notSet)";
	Argv[1] = McodeFilename;
	ArgPtr = 2;

	/* ---------------------------- */
	/* EɈVtg */
	/* ΏۂƂȂ"top_arg"ȍ~*/
	/* ---------------------------- */
        for( i=top_arg; i<argc; i++ )
	{
	        Argv[ArgPtr] = argv[i];
		ArgPtr++;
	}
	Argv[ArgPtr] = NULL;
      #if CON_MONITOR
	printf("-shifted args (arg1Arg2, arg2Arg3 ..)---\n");
	for (i=0;i<ArgPtr;i++)
	{
		printf("Arg%d=[%s]\n",i,Argv[i]);
	}
	printf("--------------------------------------------\n");
      #endif

	/* ------------------------------------------ */
	/* ̈܂͋󔒂܂ވ"`"ň͂ */
	/* ΏۂƂȂArg[1]ȍ~                 */
	/* ------------------------------------------ */
    #if DOS_ENVIRONMENT
        for( i=1; i<ArgPtr; i++ )
	{
		if ( strlen(Argv[i])==0 || strchr(Argv[i],' ') )
		{
				char	*buff;
			buff = malloc( strlen(Argv[i]) + 3 );
			if ( buff == NULL )
			{
				emgcyHeaderOutput();
				printf( "No memory for arg buffer\n" );
				emgcyExit();
			}
			strcpy( buff, "\"" );
			strcat( buff, Argv[i] );
			strcat( buff, "\"" );
		        Argv[i] = buff;
		}
	}
      #if CON_MONITOR
	printf("-inserted double quote to args include spc--\n");
	for (i=0;i<ArgPtr;i++)
	{
		printf("Arg%d=[%s]\n",i,Argv[i]);
	}
	printf("--------------------------------------------\n");
	/*sysPause();*/
      #endif
    #endif

 	/* -------------------------- */
	/* F ConsoleubN */
 	/* -------------------------- */

	if ( check_mcodefilename() < 0 )
	{
		goto _error;
	}

	if ( decide_version_no() < 0 )
	{
		goto _error;
	}
    #if CON_MONITOR
      #if 1
	winprintf("VersionDigits=%s\n", VersionDigits );
      #endif
    #endif

	/* F ConsoleubN */

	make_runtname_and_cmdline();
	Argv[0] = RuntimeProgname;

    #if CON_MONITOR
	printf("Runtimename=[%s]\n",RuntimeProgname);
	for (i=0;i<ArgPtr;i++)
	{
		printf("Arg%d=[%s]\n",i,Argv[i]);
	}
    #endif

	/* ------------------------------------ */
	/* runtimegւ̃pXŋNĂ݂  */
	/* ------------------------------------ */
	strcpy( FullpathRuntname, MyPath );
	if ( is_top_path(FullpathRuntname) == 0 )
	{
		strcat( FullpathRuntname, "\\" );
	}
	strcat( FullpathRuntname, RuntimeProgname );

    #if CON_MONITOR
	printf("---runtimegւ̃pXŋN---\n");
	printf("   spawnv(%s) \n", FullpathRuntname);
    #endif
		  /*DOS̏ꍇ,execvp()gƐeɐił܂̂spawn()ɂ */
	retcode = spawnv( P_WAIT, FullpathRuntname, &(Argv[0]) );
	if ( retcode != -1 )
	{
		exit_program(retcode); /* q̏IR[hɕԂ */
	}
	/* ------------------------------------ */
	/* pXł͋NłɎ   */
	/* ------------------------------------ */

	/* ------------------------------------ */
	/* runtimePATHT[`ŋNĂ݂    */
	/* ------------------------------------ */
    #if CON_MONITOR
	printf("---runtimePATHT[`ŋN---\n");
	printf("   spawnvp(%s)\n", RuntimeProgname);
    #endif
		  /*DOS̏ꍇ,execvp()gƐeɐił܂̂spawn()ɂ */
	retcode = spawnvp( P_WAIT, RuntimeProgname, &(Argv[0]) );
	if ( retcode != -1 )
	{
		exit_program(retcode); /* q̏IR[hɕԂ */
	}
	/* ---------------------- */
	/* pXł͋Nł */
	/* ֍sɎ   */
	/* ---------------------- */
    #if CGI_ENVIRONMENT == 0
      #if CON_MONITOR
	printf("---΃pXŕӏN---\n");
      #endif
	#include "try_multipath_exec.c"
    #endif
	/* ---------------------- */
	/* ςNł     */
	/* ---------------------- */
	emgcyHeaderOutput();
	printf( "Mind runtime not found\n" );
	emgcyExit();

_error:
	emgcyHeaderOutput();
	printf( "%s\n", ErrorMessage );
	emgcyExit();
}

#endif		/* NOT_GUI */


/*----------------------------------------------------------------------------
                                C(GUI)
----------------------------------------------------------------------------*/

#if GUI		/* Fȉ̏͑SSilent[hŏ */

#include "setargv.c"

extern int PASCAL
WinMain(	HINSTANCE	hInstance,
		HINSTANCE	hPrevInstance,
		LPSTR		lpCmdLine,
		int		nCmdShow )
{
		int		type_MyApp_exe;

   #if CON_MONITOR
	startwinconsole();
	winprintf( "Enter mindexw: lpCmdLine=[%s]\n", lpCmdLine );
    #endif

	/* Ȃ̃tpXvO𓾂 */
	GetModuleFileName(NULL, McodeFilename, sizeof(McodeFilename));
    #if CON_MONITOR
	winprintf("MyFullPathProgName=%s\n",McodeFilename);
    #endif

 	/* ---------------------- */
	/* F GUIubN */
 	/* ---------------------- */

	save_mypath();
    #if CON_MONITOR
	winprintf("MyPath=%s\n",MyPath);
    #endif

	save_mypurename( McodeFilename );
    #if CON_MONITOR
	winprintf("myPurename=%s\n",MyPurename);
    #endif

    #if WINSILENT
	if ( strcmpNocase(MyPurename,"mindexws.exe") == 0 )
    #else
	if ( strcmpNocase(MyPurename,"mindexw.exe") == 0 )
    #endif
	{
	    #if CON_MONITOR
		winprintf("Type: mindexw(s).exe MyApp args..\n");
	    #endif
		type_MyApp_exe = 0;
		copy_mcode_filename( lpCmdLine );   /* McodeFilename=argv[1] */
		add_mco_if_not( McodeFilename );
	}
	else
	{
	    #if CON_MONITOR
		winprintf("Type: MyApp.exe args..\n");
	    #endif
		type_MyApp_exe = 1;
		reject_ext( McodeFilename );	    /* .exe O */
		add_mco( McodeFilename );	    /* .mco t */
		CmdLineRemaining = lpCmdLine;
	}

    #if CON_MONITOR
	winprintf( "McodeFilename=[%s]\n", McodeFilename );
	winprintf( "CmdLineRemaining=[%s]\n", CmdLineRemaining );
    #endif

 	/* ---------------------- */
	/* F GUIubN */
 	/* ---------------------- */

	if ( check_mcodefilename() < 0 )
	{
		goto _error;
	}

	if ( decide_version_no() < 0 )
	{
		goto _error;
	}
    #if CON_MONITOR
	winprintf("VersionDigits=%s\n", VersionDigits );
    #endif

	make_runtname_and_cmdline();

    #if CON_MONITOR
	winprintf("RuntimeProgname=[%s]\nNewCmdLine=[%s]\n",
		   RuntimeProgname,      NewCmdLine);
    #endif

	{
			int	Argc;
			char	**Argv;

		setargv( &Argc, &Argv, RuntimeProgname, NewCmdLine,
			 WITH_DQUOTE );
	    #if CON_MONITOR
		winprintf("----- args after 'setargv()' ----\n");
		{
				int	i;
			for (i=0;i<=Argc;i++)
			{
				winprintf("Arg%d=[%s]\n",i,Argv[i]);
			}
		}
		winprintf("--------------------\n");
	    #endif

 		/* -------------------------- */
		/* F GUIubN     */
		/*     pXŋNĂ݂ */
	 	/* -------------------------- */

		execvp( Argv[0], (const char *const *)(&(Argv[0])) );

		/* ---------------------- */
		/* pXł͋Nł */
		/* ---------------------- */

		#include "try_multipath_exec.c"

		/* ---------------------- */
		/* ςNł     */
		/* ---------------------- */
	}

_error:
	/* -------------------------------------------- */
	/* EBhD͊JȂ̂ŃR\[ɕ\ */
	/* -------------------------------------------- */
	emgcyHeaderOutput();
	winprintf( "Error: %s\n",ErrorMessage );
	emgcyExit();

	return 1;
}

#endif		/* GUI */


/* end (mindex.c) */
