/*==========================================================================*/
/*                                                                          */
/*                   Mind version 7.0 runtime library                       */
/*                                                                          */
/*                Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                          */
/*==========================================================================*/

/*--------------------------------------------------------------------------*/
/*  t@C: ms-c.c (MS-CL̏)                                     */
/*  @\      :                                                             */
/*  쐬      :                                                             */
/*  L        :                                                             */
/*--------------------------------------------------------------------------*/


/* L^ -/
=========
Win32Ή
=========
1998.01.08	VK쐬.
1999.10.19	fsearch.srcuc_closedirvĂіYĂƂɔ
		Ci\̂łǂ̃tOԂ悤
		j
1999.10.23	c_finddir()Ȃ蒼B܂c_getfilename()p~B
/- I */


/*PAGE*/
/*----------------------------------------------------------------------------
                                 fBNg
----------------------------------------------------------------------------*/

/*;LOCAL*/

#if 0		/* ------ io.h 蔲 ------ */
struct _finddata_t {
    unsigned	attrib;
    time_t	time_create;	/* -1 for FAT file systems */
    time_t	time_access;	/* -1 for FAT file systems */
    time_t	time_write;
    _fsize_t	size;
    char	name[260];
};
typedef struct	/* ------ 4ker.c 蔲 ---- */
{					/*    fstamp.srcɂ̗L. */
	ULONG	mind_atime;		/*    ̐擪QGǵA*/
	ULONG	mind_mtime;		/*    utime()Ŏg\̂Ɠ.  */
	ULONG	mind_fsize;
	USHORT  mind_fmode;
        USHORT  mind_mark;
	ULONG               findinfo_handle;
        struct _finddata_t *findinfo_addr;
}t_mindstamps;
#endif		/* --------------------------- */



PRIVATE  void
    c_findinfo_buffSize( void )			/* ;WORD c_findinfo_buffSize */
{
	/* (.  size) */

		long		    allocsize;

	allocsize = sizeof(struct _finddata_t);
	PUSH_Q( allocsize, 0 );
}


PRIVATE  void	/* dos: <io.h> */
    c_finddir( void )			/* ;WORD c_finddir */
{
	/* (wildcard(xڂ͋), mindstamp  errorno) */

		t_mindstamps 	   *stampStructAddr;
                char         	   *wildcard;
		ULONG		    count;
		long		    allocsize;
		struct _finddata_t  *findinfo;
		long		    handle;
                tErrcode            retcode;

	stampStructAddr = (t_mindstamps *)POP_A_OF_S;
	count    = POP_C;
	wildcard = (char *)POP_A;

	if ( count )
	{
		/* ŏ̌ */
		findinfo = stampStructAddr->findinfo_addr;
		handle = _findfirst( wildcard, findinfo );
		if ( handle == -1 )
		{
			retcode = errno;		/* ꂪ */
			goto _error;
		}
		stampStructAddr->findinfo_handle = handle;
	}
	else
	{	/* ̌ */
		findinfo = stampStructAddr->findinfo_addr;
		handle   = stampStructAddr->findinfo_handle;

		retcode = _findnext( handle, findinfo );
		if ( retcode == -1 )
		{
			retcode = errno;
			goto _error;
		}
	}

	/* --  (first/nextʏ) -- */
	stampStructAddr->mind_atime = findinfo->time_access;
	stampStructAddr->mind_mtime = findinfo->time_write;
	stampStructAddr->mind_fsize = findinfo->size;
	stampStructAddr->mind_fmode = findinfo->attrib;
	/* OƃG[R[hς */
	PUSH_S( findinfo->name, 0 );
        PUSH_Q( 0, 0 );
	return;

_error:
	/* s(name͐ς܂Ȃ) */
	if ( retcode == 0 )
	{
		/* ȂƂ͖ƎvÔ */
		retcode = ENOMEM;
	}
        PUSH_Q( retcode, 0 );
	return;
}


PRIVATE  void	/* dos: <io.h> */
    c_closedir( void )			/* ;WORD c_closedir */
{
	/* (mindstamp  .) */

		t_mindstamps 	   *stampStructAddr;
		struct _finddata_t *findinfo;
		long		    handle;

	stampStructAddr = (t_mindstamps *)POP_A_OF_S;
	if ( stampStructAddr == NULL )
	{
		return;
	}

	handle = stampStructAddr->findinfo_handle;
	if ( handle != -1 )
	{
		_findclose( handle );
		stampStructAddr->findinfo_handle = -1;
	}
}


/*PAGE*/
/*----------------------------------------------------------------------------
                    t@CANZXoCiɂ(MS-CL)
----------------------------------------------------------------------------*/

/*;LOCAL*/

PRIVATE  void
    c_O_BINARY( void )			/* ;WORD O_BINARY */
{
	/* (.  mode) */

	PUSH_Q( O_BINARY, 0 );
}

PRIVATE  void
    c_O_TEXT( void )			/* ;WORD O_TEXT */
{
	/* (.  mode) */

	PUSH_Q( O_TEXT, 0 );
}

PRIVATE  void
    c_setmode( void )			/* ;WORD c_setmode */
{
	/* (handle, mode  .) */

		int	handle;
		int	mode;

	mode   = POP_U_OF_Q;
	handle = POP_U_OF_Q;

	setmode( handle, mode );
}


/*;GLOBAL*/

/* end of 'ms-c.c' */
