/*==========================================================================*/
/*                                                                          */
/*                   Mind version 7.0 runtime library                       */
/*                                                                          */
/*                Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                          */
/*==========================================================================*/

/*--------------------------------------------------------------------------*/
/*  t@C: permission.c                                                */
/*  @\      : MR[ht@Cxp[~bV                      */
/*  쐬      : Ћ (1997.11.03)                                         */
/*--------------------------------------------------------------------------*/

/* L^ -/
1996.11.03      VK쐬(mindex.c, mindrunt.c CN[h).
/- I */

/*PAGE*/

int check_mcode_permission( struct stat *statBuffer )
{
		int	flmode;

		uid_t	fluid;
		uid_t	flgid;

		uid_t	myuid;
		uid_t	myeuid;
		gid_t	mygid;
		gid_t	myegid;

	flmode = statBuffer->st_mode;
	fluid  = statBuffer->st_uid;
	flgid  = statBuffer->st_gid;

/*	printf("File: mode=%04x | uid=%04x gid=%04x\n",		TEST*/
/*		      flmode,     fluid,   flgid);		TEST*/

	/* -------------------------- */

	myuid  = getuid();
	myeuid = geteuid();

	mygid  = getgid();
	myegid = getegid();

/*	printf("MY uid=%04x euid=%04x gid=%04x egid=%04x\n",	TEST*/
/*		   myuid,    myeuid,    mygid,    myegid );	TEST*/

	/* -------------------------- */

/*	if ( flmode & 0xc00 )  */

	if ( myuid != myeuid )
	{
		/* SUID'ed or SGID'ed */
/*		printf("== SUID'ed process ==\n");	TEST*/
		if ( fluid != myeuid )
		{	/* McodeUID != UID */
/*			printf("SUIDFs\n");	TEST*/
			return 0;
		}
/*		printf("SUIDF\n");		TEST*/
	}

	if ( fluid == myeuid )
	{	/* Mcodet@CI[ig */
		if ( flmode & 0x40 )		/* X - - */
		{
/*			printf("userxrbgv\n");  TEST*/
			return 1;
		}
	}

	if ( flgid == myegid )
	{	/* Mcodet@CO[ṽO[v */
		if ( flmode & 0x08 )		/* - X - */
		{
/*			printf("groupxrbgv\n");  TEST*/
			return 1;
		}
	}

	/* otherxrbg */

	if ( flmode & 0x01 )		        /* - - X */
	{
/*		printf("otherxrbgv\n");  	 TEST*/
		return 1;
	}

	return 0;
}


/* end */
