#include "tkheader.h"
#include <stdarg.h>
#include <stdlib.h>	/* for atoi() */

#include "wincons.h"
#include "jumpbufmax.h"
#include "kermain.h"

#define tcl_mind_monitor 0
	/* 1: j^                               */
	/* 2: kermain.cSTARTUP_MONITORɈp */

#define eval_in_initializing 1
	/* 0: fBXvCTCYvZXLbv       */
	/* 1: {ԁivZj                     */



/*-----------------------------------------------------------------------------
                            Tcl/TkMindĂяo
-----------------------------------------------------------------------------*/

static void
enterMind( void )
{
		int	old_count;
		int	new_count;

	old_count = RestartEnvCount;
	new_count = old_count + 1;
  #if tcl_mind_monitor
	winprintf( "RestartEnvCount %d->%d\n", old_count, new_count );
/*	winpause();*/
/*	endwinconsole();*/
  #endif
	if ( new_count >= jmp_buf_max )
	{
		emgcyHeaderOutput();
		winprintf("RestartEnvCount(in Mind runtime) overflow\n");
		emgcyCgiExit();
	}
	RestartEnvCount = new_count;
        DataStackBase[RestartEnvCount] = DstackPointer; /* ݈ʒux[X */
}

static void
exitMind( void )
{
		int	old_count;
		int	new_count;

	old_count = RestartEnvCount;
	new_count = old_count - 1;
	if ( new_count < 0 )
	{
		emgcyHeaderOutput();
		winprintf("RestartEnvCount underflow\n");
		emgcyCgiExit();
	}
	RestartEnvCount = new_count;
  #if tcl_mind_monitor
	winprintf( "RestartEnvCount %d->%d\n", old_count, new_count );
/*	winpause();*/
  #endif
}


#include "c2tcl.c"


/* ------------------------------------------------------------------ */

#define EVENT_MAX_ARGS 10

static int
mindcmd0( ClientData clientdata, Tcl_Interp *interp,
		int argc, char *argv[] )
{
		int	i;

	if ( argc < 2 )	    /*  #0           #1             */
	{	/* Œł "mindcmd0", "Cxg"  */
		goto _mindcmd0_exit;
	}

  #if tcl_mind_monitor
	winprintf( "Enter mindcmd0()\n" );
	{
		int	i;
		winprintf("--------------------\n");
		for (i=0;i<argc;i++)
		{
			winprintf("arg%d=[%s]\n",i,argv[i]);
		}
		winprintf("--------------------\n");
	}
  #endif

	/*--------*/
	enterMind();	/* ŃX^bN|C^x[Xݒ肳 */
	/*--------*/
  #if tcl_mind_monitor
	winpause(); endwinconsole();
  #endif

	for ( i=2; i<argc; i++ )		/* "Cxg"̎ς */
	{
		pushs( argv[i], strlen(argv[i]) ); /* Cxgpush */
	}
	pushq( argc-2, 0 );			   /* push(Œ=0) */
	pushs( argv[1], strlen(argv[1]) );	   /* Cxgpush */
	/*=============================*/
	call_dispatcher_with_hotno( 23 );   /* HOT23uCxgv */
/*	call_dispatcher_with_hotno( 2 );*/  /* HOT2 uCxgOv */
	/*=============================*/   /* HOT2΂gĂ݂p~ */

  #if tcl_mind_monitor
	startwinconsole();			/*͕Kv*/
  #endif
	/*--------*/
	exitMind();
	/*--------*/
  #if tcl_mind_monitor
	winpause(); endwinconsole();
  #endif

_mindcmd0_exit:
	sprintf( interp->result, "" );
	return TCL_OK;
}

static int
mindcmd( ClientData clientdata, Tcl_Interp *interp,
		int argc, char *argv[] )
{
		int	i;
		int	structSize;
		char	*argvB[EVENT_MAX_ARGS];
		struct Tcl_DString  *tclvalue[EVENT_MAX_ARGS];
		char	*argSpace;

	if ( argc < 2 )	    /*  #0           #1            */
	{	/* Œł "mindcmd", "Cxg"  */
		goto _mindcmd_exit;
	}

  #if tcl_mind_monitor
	winprintf( "Enter mindcmd()\n" );
	{
		int	i;
		winprintf("--------------------\n");
		for (i=0;i<argc;i++)
		{
			winprintf("arg%d=[%s]\n",i,argv[i]);
		}
		winprintf("--------------------\n");
	}
  #endif

	if ( argc > EVENT_MAX_ARGS )
	{
		argc = EVENT_MAX_ARGS;
	}

	structSize = sizeof( struct Tcl_DString );
	for( i=0; i<argc; i++ )
	{
		argSpace =(char *)malloc( (unsigned)structSize );
		tclvalue[i] = (struct Tcl_DString *)argSpace;
		to_native( interp, tclvalue[i], argv[i] );
		argvB[i] = Tcl_DStringValue( tclvalue[i] );
	}

  #if tcl_mind_monitor
    #if 0
	winprintf( "To native converted:\n" );
	{
		int	i;
		winprintf("--------------------\n");
		for (i=0;i<argc;i++)
		{
			winprintf("arg%d=[%s]\n",i,argvB[i]);
		}
		winprintf("--------------------\n");
	}
    #endif
  #endif

	/*--------*/
	enterMind();	/* ŃX^bN|C^x[Xݒ肳 */
	/*--------*/
  #if tcl_mind_monitor
	winpause(); endwinconsole();
  #endif

	for ( i=2; i<argc; i++ )		/* "Cxg"̎ς */
	{
		pushs(argvB[i],strlen(argvB[i]));  /* Cxgpush */
	}
	pushq( argc-2, 0 );			   /* push(Œ=0) */
	pushs( argvB[1], strlen(argvB[1]) );	   /* Cxgpush */
	/*=============================*/
	call_dispatcher_with_hotno( 23 );   /* HOT23uCxgv */
	/*=============================*/

  #if tcl_mind_monitor
	startwinconsole();			/*͕Kv*/
  #endif
	/*--------*/
	exitMind();
	/*--------*/
  #if tcl_mind_monitor
	winpause(); endwinconsole();
  #endif

	for( i=0; i<argc; i++ )
	{
		free_utf( tclvalue[i] );
		free( (void *)tclvalue[i] );
	}

_mindcmd_exit:
	sprintf( interp->result, "" );
	return TCL_OK;
}


/*-----------------------------------------------------------------------------
                                   
-----------------------------------------------------------------------------*/

static void
register_my_commands(  Tcl_Interp *interp  )
{
	Tcl_CreateCommand( interp, "mindcmd", mindcmd,
			(ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
	Tcl_CreateCommand( interp, "mindcmd0", mindcmd0,
			(ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
}

/*int mainword_done = 0;*/

int
Tcl_AppInit( Tcl_Interp *interp )	/* Interpreter for application. */
{
	if (Tcl_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	if (Tk_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	Tcl_StaticPackage(interp, "Tk", Tk_Init, (Tcl_PackageInitProc *) NULL);

	MyInterp = interp;

/*	MyEncoding = Tcl_GetEncoding( interp, "cp932" );*/
/*	if ( MyEncoding == NULL ) {*/
/*		return TCL_ERROR;*/
/*	}*/

	register_my_commands( interp );

    #if eval_in_initializing
	decide_display_size_and_position( interp );
    #endif

	/*----kermain.c---*/
	execute_main_word( Argv[1] );	/* FMR[ht@C */
/*	mainword_done = 1;*/
    #if tcl_mind_monitor
      #if 0
	winprintf("after execute 'execute_main_word()' in kermain.c\n");
	winpause();
      #endif
    #endif
	/*----------------*/

	return TCL_OK;
}


/*-----------------------------------------------------------------------------
                              CEGg
-----------------------------------------------------------------------------*/

#include "setargv.c"


HINSTANCE myInstance;

long get_my_icon( void )
{
	return (long)LoadIcon( myInstance, "MindExeIcon" );
}


#if 0
HANDLE	iconhandle;
#endif

extern "C" int PASCAL
WinMain(	HINSTANCE	hInstance,
		HINSTANCE	hPrevInstance,
		LPSTR		lpCmdLine,
		int		nCmdShow )
{
		static char myname[MAX_PATH];
		static char startuptclname[MAX_PATH];
		char 	   *mynamep[2];
		char	  **argv;
		int	    argc;
		int		icon;
		static char iconbuff[10];

	myInstance = hInstance;

	prepare_standardout();	/* : startwinconsole()̑OɕKv */

  #if tcl_mind_monitor
	startwinconsole();	/* ň񂾂sĂ */
    #if 0
	winprintf("tclstartup: WinMainInstance=%08lX\n",myInstance);
	winpause();
    #endif
  #endif

  #if 0
	iconhandle = LoadIcon( hInstance, "MindExeIcon" );

	if ( iconhandle == NULL )
	{	/* G[ */
		startwinconsole();
		winprintf("Error\n");
		winpause();
	}
	else
	{	/*  */
		startwinconsole();
		winprintf("OK\n");
		winpause();
	}
  #endif

	GetModuleFileName(NULL, myname, sizeof(myname));

  #if tcl_mind_monitor
	winprintf("-- I am mindrunt(GUI) --\n");
	winprintf("cmdline=%s\n", lpCmdLine );
	winprintf("myname =%s\n", myname);
	winpause();
  #endif

	CommandLine = lpCmdLine;		/* ptrdef.cŕϐ` */

	setargv( &argc, &argv, myname, lpCmdLine, NO_DQUOTE );
	Argc = argc;     			/* ptrdef.cŕϐ` */
	Argv = argv;     			/* ptrdef.cŕϐ` */

  #if tcl_mind_monitor
	{
		int	i;
		winprintf("--------------------\n");
		for (i=0;i<Argc;i++)
		{
			winprintf("Arg%d=[%s]\n",i,Argv[i]);
		}
		winprintf("--------------------\n");
		winpause();
	}
    #if tcl_mind_monitor < 2
	endwinconsole();
    #endif
  #endif

        if ( Argc<2 || strcmp(Argv[1],"")==0 )
	{
		emgcyHeaderOutput();
		winprintf("No M-code file name.\n");
		emgcyCgiExit();
        }

  #if tcl_mind_monitor
    #if 1
	winprintf("start Tcl/Tk\n");
	winpause();
      #if tcl_mind_monitor < 2
	endwinconsole();
      #endif
    #endif
  #endif

	/* -- start tk_Main() -- */

	setlocale(LC_ALL, "C");

	mynamep[0] = myname;

	icon = get_my_icon();
	mynamep[1] = ltoa( icon, iconbuff, 10 );
		/* F[1]Rigyʎdl */

	Tk_Main( 2, mynamep, Tcl_AppInit);
	return 1;
}

