/*===========================================================================*/
/*                                                                           */
/*                    Mind version 7.0 runtime library                       */
/*                                                                           */
/*                 Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*  t@C: 2ker22.c (kernel.c̃CN[ht@C)                    */
/*  @\      : 񑀍̂AR[hϊ                             */
/*  쐬      : Ћ (1994.09.01)                                          */
/*  L        : IWi̓AZuLq('R4'$2KER22.ASM)                */
/*---------------------------------------------------------------------------*/


/* L^ -/

1989.6.2        PureMindPRO ׂ̈MASMLqɕύXB

1989.7.5        JMPN߂JMP߂ɕύXB(R[hv̌I)

1995.10.07	uvuvurv $2ker2.c 
		ړB

1996.03.10	EUCR[hΉɂ.

    		itiMojiOhmojiHenkan()iꕶ啶ϊj̏ȗ
		i$2ker1.cŊɒ`ĂĂ啶ϊp̃}
		NgƁAʊ֐ɉ񂷂̂ߒړWĴQ_j

1996.03.10	uihrϊvuVtgihrϊvT|[gB

1996.06.14	uihrϊv@@@uꕶrihrihrϊvA
		uVtgihrϊvuꕶihrrihrϊv
		ɂꂼꖼ̕ύXBiRpCe󂯂̂
		ӂ̂Ɓj

2000.05.05	uitiMojiZenkakuHenkan() ꕶSpϊvт̒O
		ɂϊe[uCiEUCo[Ŵ݁jAEUC
		pJiꍇɁASpϊł悤ɂBi
		ł͑SpłĂȂj

/- I */

/*PAGE*/
/*-----------------------------------------------------------------------------
                          ꕶrihrihrϊ
-----------------------------------------------------------------------------*/

	/* -------------------- */
	/* R[ȟnɈˑ */
	/* -------------------- */

PRIVATE void
    c_sjis_to_jis( void )	    /* ;WORD  ꕶrihrihrϊ .N */
{
        /* (Vtgihr(16)  ihr(16)) */

		USHORT	charCode;
		UCHAR	high;
		UCHAR	low;

	charCode = READ_U_OF_Q;
	RETURN_IF( charCode <= 255 );		/* ASCIIȂ疳 */

	high = charCode >> 8;			/* ʃoCg */
	low  = charCode & 0xff;			/* ʃoCg */

        if ( high >= 0xe0 )			/* E0ȏHEE */
	{
		high -= 0x40;			/* ȂA0H`ɕ␳ */
	}
        high -= 0x70;

	if ( low & 0x80 )
	{
        	low--;
        }

        high <<= 1;
        if ( low >= 0x9e )
	{
        	low -= 0x5e;
        }
        else
	{
        	high--;
        }

	low -= 0x1f;

	WRITE_U_OF_Q( high<<8 | low );
}

/*PAGE*/
/*-----------------------------------------------------------------------------
                          ꕶihrrihrϊ
-----------------------------------------------------------------------------*/

	/* -------------------- */
	/* R[ȟnɈˑ */
	/* -------------------- */

PRIVATE void
    c_jis_to_sjis( void )	    /* ;WORD  ꕶihrrihrϊ .N */
{
        /* (ihr(16)  Vtgihr(16)) */

		USHORT	charCode;
		UCHAR	high;
		UCHAR	low;

	charCode = READ_U_OF_Q;
	RETURN_IF( charCode <= 255 );		/* ASCIIȂ疳 */

	high = charCode >> 8;			/* ʃoCg */
	low  = charCode & 0xff;			/* ʃoCg */

        low += 0x1f;

	if ( !(high & 1) )
	{	/* LSB=0 */
        	high >>= 1;
        	high--;
        	low += 0x5e;
	}
	else
	{	/* LSB=1 */
        	high >>= 1;
        }

	if ( low >= 0x7f )
	{
		low++;
	}

	high += 0x71;
	if ( high >= 0xa0 )
        {
        	high += 0x40;
        }

	WRITE_U_OF_Q( high<<8 | low );
}


/*PAGE*/
/*-----------------------------------------------------------------------------
                             oCiϊ
-----------------------------------------------------------------------------*/

	/* -------------------- */
	/* R[ȟnɈˑ */
	/* -------------------- */

#define	ASCII_0		0x30
#define	ASCII_9		0x39
#define	ASCII_A		0x41
#define	ASCII_F		0x46
#define	ASCII_a		0x61
#define	ASCII_f		0x66

#if SJIS_CHARACTER
#define KANJI_0       0x824F
#define KANJI_9       0x8258
#define KANJI_A       0x8260
#define KANJI_F       0x8265
#define KANJI_a       0x8281
#define KANJI_f       0x8286
#else /*EUC*/
#define	KANJI_0       0xa3b0
#define	KANJI_9       0xa3b9
#define	KANJI_A       0xa3c1
#define	KANJI_F       0xa3c6
#define	KANJI_a       0xa3e1
#define	KANJI_f       0xa3e6
#endif

/*PAGE*/
/*-----------------------------------------------------------------------------
                              ꕶ啶ϊ
-----------------------------------------------------------------------------*/

PRIVATE void
    itiMojiOhmojiHenkan( void )    /* ;WORD ꕶ啶ϊ .N */
{
        /* (char(8/16)  char(8/16)) */

		USHORT	charCode;

	charCode = READ_U_OF_Q;

	if ( charCode > 255 )
	{	/* KANJI */  /*2ker1.cŒ`}N */
		charCode = upperCharKANJI(charCode);
	}
	else
	{	/* ASCII */  /*2ker1.cŒ`}N */
		charCode = upperCharASCII(charCode);
	}

	WRITE_U_OF_Q( charCode );
}

/*PAGE*/
/*-----------------------------------------------------------------------------
                            ꕶlϊ
-----------------------------------------------------------------------------*/

PRIVATE int			/* ߒl:oCi(G[͕̎) */
    check_0_to_9(
		USHORT	charCode	/* :R[h(܂ފ) */
    		)
{
	if ( charCode > 255 )
	{	/* KANJI */
		if ( charCode >= KANJI_0 && charCode <= KANJI_9 )
		{
			return (charCode - KANJI_0);
		}
		else
		{
			return -1;
		}
	}
	else
	{	/* ASCII */
		if ( charCode >= ASCII_0 && charCode <= ASCII_9 )
		{
			return (charCode - ASCII_0);
		}
		else
		{
			return -1;
		}
	}
}

PRIVATE void
    itiMojiSutiHenkan( void )	/* ;WORD ꕶlϊ .N */
{
        /* (char(8/16)  binary, ^U) */

		USHORT	charCode;
		int	result;

	charCode = READ_U_OF_Q;
	result = check_0_to_9(charCode);

	if ( result < 0 )
	{	/* s */
		WRITE_U_OF_Q( 0 );		/* oCi(0)push */
		PUSH_0;				/* Upush */
	}
	else
	{
		WRITE_U_OF_Q( result );		/* oCipush */
		PUSH_1;				/* ^push */
	}
}

/*PAGE*/
/*-----------------------------------------------------------------------------
                        ꕶlϊE\Zi
-----------------------------------------------------------------------------*/

PRIVATE int			/* ߒl:oCi(G[͕̎) */
    check_0_to_F(
		USHORT	charCode	/* :R[h(܂ފ) */
    		)
{
	if ( charCode > 255 )
	{	/* KANJI */
		if ( charCode >= KANJI_0 && charCode <= KANJI_9 )
		{
			return (charCode - KANJI_0);
		}
		else
		{
			if ( charCode >= KANJI_A && charCode <= KANJI_F )
			{
				return (charCode - KANJI_A + 10 );
			}
			else if ( charCode >= KANJI_a && charCode <= KANJI_f )
			{
				return (charCode - KANJI_a + 10 );
			}
			else
			{
				return -1;
			}
		}
	}
	else
	{	/* ASCII */
		if ( charCode >= ASCII_0 && charCode <= ASCII_9 )
		{
			return (charCode - ASCII_0);
		}
		else
		{
			if ( charCode >= ASCII_A && charCode <= ASCII_F )
			{
				return (charCode - ASCII_A + 10 );
			}
			else if ( charCode >= ASCII_a && charCode <= ASCII_f )
			{
				return (charCode - ASCII_a + 10 );
			}
			else
			{
				return -1;
			}
		}
	}
}

/*PAGE*/

PRIVATE void
    itiMojiSutiHenkanHex( void )	/* ;WORD ꕶlϊE\Zi .N */
{
        /* (char(8/16)  binary, ^U) */

		USHORT	charCode;
		int	result;

	charCode = READ_U_OF_Q;
	result = check_0_to_F(charCode);

	if ( result < 0 )
	{	/* s */
		WRITE_U_OF_Q( 0 );		/* oCi(0)push */
		PUSH_0;				/* Upush */
	}
	else
	{
		WRITE_U_OF_Q( result );		/* oCipush */
		PUSH_1;				/* ^push */
	}
}

/*PAGE*/
/*-----------------------------------------------------------------------------
                              ꕶSpϊ
-----------------------------------------------------------------------------*/

	/* -------------------- */
	/* R[ȟnɈˑ */
	/* -------------------- */

        /* (:̃e[uR4găvOŐ)*/

#if SJIS_CHARACTER

USHORT	KanjiTable[] =
{
0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,   /* 00-07 */
0x0008, 0x0009, 0x000A, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F,   /* 08-0F */
0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017,   /* 10-17 */
0x0018, 0x0019, 0x001A, 0x001B, 0x001C, 0x001D, 0x001E, 0x001F,   /* 18-1F */

0x8140, 0x8149, 0x8168, 0x8194, 0x8190, 0x8193, 0x8195, 0x8166,   /* 20-27 */
0x8169, 0x816A, 0x8196, 0x817B, 0x8143, 0x817C, 0x8144, 0x815E,   /* 28-2F */
0x824F, 0x8250, 0x8251, 0x8252, 0x8253, 0x8254, 0x8255, 0x8256,   /* 30-37 */
0x8257, 0x8258, 0x8146, 0x8147, 0x8183, 0x8181, 0x8184, 0x8148,   /* 38-3F */
0x8197, 0x8260, 0x8261, 0x8262, 0x8263, 0x8264, 0x8265, 0x8266,   /* 40-47 */
0x8267, 0x8268, 0x8269, 0x826A, 0x826B, 0x826C, 0x826D, 0x826E,   /* 48-4F */

0x826F, 0x8270, 0x8271, 0x8272, 0x8273, 0x8274, 0x8275, 0x8276,   /* 50-57 */
0x8277, 0x8278, 0x8279, 0x816D, 0x818F, 0x816E, 0x814F, 0x8151,   /* 58-5F */
0x8140, 0x8281, 0x8282, 0x8283, 0x8284, 0x8285, 0x8286, 0x8287,   /* 60-67 */
0x8288, 0x8289, 0x828A, 0x828B, 0x828C, 0x828D, 0x828E, 0x828F,   /* 68-6F */
0x8290, 0x8291, 0x8292, 0x8293, 0x8294, 0x8295, 0x8296, 0x8297,   /* 70-77 */
0x8298, 0x8299, 0x829A, 0x816F, 0x8162, 0x8170, 0x8150, 0x007F,   /* 78-7F */

0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087,   /* 80-87 */
0x0088, 0x0089, 0x008A, 0x008B, 0x008C, 0x008D, 0x008E, 0x008F,   /* 88-8F */
0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097,   /* 90-97 */
0x0098, 0x0099, 0x009A, 0x009B, 0x009C, 0x009D, 0x009E, 0x009F,   /* 98-9F */

0x8140, 0x8142, 0x8175, 0x8176, 0x8141, 0x8145, 0x8392, 0x8340,   /* A0-A7 */
0x8342, 0x8344, 0x8346, 0x8348, 0x8383, 0x8385, 0x8387, 0x8362,   /* A0-AF */
0x815B, 0x8341, 0x8343, 0x8345, 0x8347, 0x8349, 0x834A, 0x834C,   /* B0-B7 */
0x834E, 0x8350, 0x8352, 0x8354, 0x8356, 0x8358, 0x835A, 0x835C,   /* B0-BF */
0x835E, 0x8360, 0x8363, 0x8365, 0x8367, 0x8369, 0x836A, 0x836B,   /* C0-C7 */
0x836C, 0x836D, 0x836E, 0x8371, 0x8374, 0x8377, 0x837A, 0x837D,   /* C0-CF */
0x837E, 0x8380, 0x8381, 0x8382, 0x8384, 0x8386, 0x8388, 0x8389,   /* D0-D7 */
0x838A, 0x838B, 0x838C, 0x838D, 0x838F, 0x8393, 0x814A, 0x814B,   /* D0-DF */

0x00E0, 0x00E1, 0x00E2, 0x00E3, 0x00E4, 0x00E5, 0x00E6, 0x00E7,   /* E0-E7 */
0x00E8, 0x00E9, 0x00EA, 0x00EB, 0x00EC, 0x00ED, 0x00EE, 0x00EF,   /* E8-EF */
0x00F0, 0x00F1, 0x00F2, 0x00F3, 0x00F4, 0x00F5, 0x00F6, 0x00F7,   /* F0-F7 */
0x00F8, 0x00F9, 0x00FA, 0x00FB, 0x00FC, 0x00FD, 0x00FE, 0x00FF,   /* F8-FF */
};

#else /*EUC*/

USHORT	KanjiTable[] =
{
0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,   /* 00-07 */
0x0008, 0x0009, 0x000A, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F,   /* 08-0F */
0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017,   /* 10-17 */
0x0018, 0x0019, 0x001A, 0x001B, 0x001C, 0x001D, 0x001E, 0x001F,   /* 18-1F */

0xA1A1, 0xA1AA, 0xA1C9, 0xA1F4, 0xA1F0, 0xA1F3, 0xA1F5, 0xA1C7,   /* 20-27 */
0xA1CA, 0xA1CB, 0xA1F6, 0xA1DC, 0xA1A4, 0xA1DD, 0xA1A5, 0xA1BF,   /* 28-2F */
0xA3B0, 0xA3B1, 0xA3B2, 0xA3B3, 0xA3B4, 0xA3B5, 0xA3B6, 0xA3B7,   /* 30-37 */
0xA3B8, 0xA3B9, 0xA1A7, 0xA1A8, 0xA1E3, 0xA1E1, 0xA1E4, 0xA1A9,   /* 38-3F */

0xA1F7, 0xA3C1, 0xA3C2, 0xA3C3, 0xA3C4, 0xA3C5, 0xA3C6, 0xA3C7,   /* 40-47 */
0xA3C8, 0xA3C9, 0xA3CA, 0xA3CB, 0xA3CC, 0xA3CD, 0xA3CE, 0xA3CF,   /* 48-4F */
0xA3D0, 0xA3D1, 0xA3D2, 0xA3D3, 0xA3D4, 0xA3D5, 0xA3D6, 0xA3D7,   /* 50-57 */
0xA3D8, 0xA3D9, 0xA3DA, 0xA1CE, 0xA1EF, 0xA1CF, 0xA1B0, 0xA1B2,   /* 58-5F */

0xA1A1, 0xA3E1, 0xA3E2, 0xA3E3, 0xA3E4, 0xA3E5, 0xA3E6, 0xA3E7,   /* 60-67 */
0xA3E8, 0xA3E9, 0xA3EA, 0xA3EB, 0xA3EC, 0xA3ED, 0xA3EE, 0xA3EF,   /* 68-6F */
0xA3F0, 0xA3F1, 0xA3F2, 0xA3F3, 0xA3F4, 0xA3F5, 0xA3F6, 0xA3F7,   /* 70-77 */
0xA3F8, 0xA3F9, 0xA3FA, 0xA1D0, 0xA1C3, 0xA1D1, 0xA1B1, 0xA1A1,   /* 78-7F */

0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087,   /* 80-87 */
0x0088, 0x0089, 0x008A, 0x008B, 0x008C, 0x008D, 0x008E, 0x008F,   /* 88-8F */
0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097,   /* 90-97 */
0x0098, 0x0099, 0x009A, 0x009B, 0x009C, 0x009D, 0x009E, 0x009F,   /* 98-9F */

/*2000.05.05ȉC*/
0xa1a1, 0xa1a3, 0xa1d6, 0xa1d7, 0xa1a2, 0xa1a6, 0xa5f2, 0xa5a1,   /* A0-A7 */
0xa5a3, 0xa5a5, 0xa5a7, 0xa5a9, 0xa5e3, 0xa5e5, 0xa5e7, 0xa5c3,   /* A0-AF */
0xa1bc, 0xa5a2, 0xa5a4, 0xa5a6, 0xa5a8, 0xa5aa, 0xa5ab, 0xa5ad,   /* B0-B7 */
0xa5af, 0xa5b1, 0xa5b3, 0xa5b5, 0xa5b7, 0xa5b9, 0xa5bb, 0xa5bd,   /* B0-BF */
0xa5bf, 0xa5c1, 0xa5c4, 0xa5c6, 0xa5c8, 0xa5ca, 0xa5cb, 0xa5cc,   /* C0-C7 */
0xa5cd, 0xa5ce, 0xa5cf, 0xa5d2, 0xa5d5, 0xa5d8, 0xa5db, 0xa5de,   /* C0-CF */
0xa5df, 0xa5e0, 0xa5e1, 0xa5e2, 0xa5e4, 0xa5e6, 0xa5e8, 0xa5e9,   /* D0-D7 */
0xa5ea, 0xa5eb, 0xa5ec, 0xa5ed, 0xa5ef, 0xa5f3, 0xa1ab, 0xa1ac,   /* D0-DF */
/*2000.05.05ȏC*/

0x00E0, 0x00E1, 0x00E2, 0x00E3, 0x00E4, 0x00E5, 0x00E6, 0x00E7,   /* E0-E7 */
0x00E8, 0x00E9, 0x00EA, 0x00EB, 0x00EC, 0x00ED, 0x00EE, 0x00EF,   /* E8-EF */
0x00F0, 0x00F1, 0x00F2, 0x00F3, 0x00F4, 0x00F5, 0x00F6, 0x00F7,   /* F0-F7 */
0x00F8, 0x00F9, 0x00FA, 0x00FB, 0x00FC, 0x00FD, 0x00FE, 0x00FF,   /* F8-FF */
};

#endif	/*EUC*/

/*PAGE*/

PRIVATE void
    itiMojiZenkakuHenkan( void )	/* ;WORD ꕶSpϊ .N */
{
        /* (char(8/16)  char(16)) */

		USHORT	charCode;

	charCode = READ_U_OF_Q;
#if SJIS_CHARACTER
	RETURN_IF( charCode > 255 )	/* SJISSpȂ炱Ń^[ */
#else /*EUC*/
	if ( charCode > 255 )
	{
		/* EUC̑Spł */
		if ( (charCode>>8) != 0x8e )
		{
			return;
		}
		/* ʃoCg=0x8e(EUC̔pJi) */
		/* 2oCg␳ (2000.05.05C) */
		charCode = charCode & 0xff;   /*ANC̔pJiɗՎϊ  */
	}				      /*  ĂSp */
#endif
	WRITE_U_OF_Q( KanjiTable[charCode] );
}


/* end of '2ker22.c' */
