/*==========================================================================*/
/*                                                                          */
/*                   Mind version 7.0 runtime library                       */
/*                                                                          */
/*                Copyright (C) 1998 by Rigy Corporation                    */
/*                                                                          */
/*==========================================================================*/

/*--------------------------------------------------------------------------*/
/*  t@C: mind2tcl.c (Tcl/TkpP)                                   */
/*  @\      :                                                             */
/*  쐬      :                                                             */
/*  L        :                                                             */
/*--------------------------------------------------------------------------*/


/* L^ -/
1998.05.03	Win32 GUI pɐVK쐬
1998.09.17	uextern int display_center_x/yv폜
1998.09.17	MindPufBXvCwvp~Äʒu
		uTcl/TklXgvꂽ
		MindPufBXvCxvp~邪Pԍ
		Ȃ悤ɖȃV{ɕύX݂̂Ƃ
1998.09.18	WXĝ߁Au]ElCeBuvu]
		lElCeBuvǉ
		iԘACFc2tcl.cj
1998.09.27	ũACR𓾂vAut@C̃ACR𓾂vA
		uACRύXOv`
1998.10.19	u]lOvǉiuACRύXOvƈj
1998.10.29	utse|rihrϊv`
		urihr|tseϊv`
2000.10.24	Tcl/TkĂяoSʕύXBic2tcl.ĉقpopȂj
		u]vǉB
		utse|rihrϊvurihr|tseϊv폜B
/- I */


/*PAGE*/

#include <imm.h>

#include "c2tcl.h"
#include "tclstartup.h"



/* -------------------------------------------------------------------- */
PRIVATE void
    c_eval( void )				/* ;WORD ] */
{
        /* (script  .) */

	eval_string();
}

/* -------------------------------------------------------------------- */
PRIVATE void
    c_eval_multi( void )              		/* ;WORD ] */
{
        /* (word1, word2, .., wordN, N  .) */

	eval_multi_words();
}


/* -------------------------------------------------------------------- */
PRIVATE void
    c_eval_return_value( void )		 	/* ;WORD ]l */
{
        /* (script  value) */

	eval_string_return_value( 0 );	  /* req_success=0 */
}

PRIVATE void
    c_eval_return_value_0( void )		/* ;WORD ]lO */
{
        /* (script  value/errmsg, 1/0) */

	eval_string_return_value( 1 );	  /* req_success=1 */
}



/* -------------------------------------------------------------------- */
PRIVATE void
    c_setvar( void )              		/* ;WORD  */
{
        /* (value, varname  .) */

	set_var();
}


/* -------------------------------------------------------------------- */
PRIVATE void
    c_getvar( void )              		/* ;WORD c_getvar */
{
        /* (varname, translate  value) */

	get_var();
}


/* -------------------------------------------------------------------- */
PRIVATE void
    c_evalfile( void )              		/* ;WORD t@C] */
{
	/* (filename  .) */

	eval_file();
}

/* ------------------------------------------------------------------ */
PRIVATE void
    c_get_my_icon( void )			/* ;WORD ̃ACR𓾂 */
{
        /* (.  ACRnh(0=G[)) */

		int	handle;

	handle = get_my_icon();
	PUSH_Q( handle , 0 );
}

PRIVATE void
    c_get_file_icon( void )	/* ;WORD t@C̃ACR𓾂O */
{
        /* (t@C(ASCIZ)  ACRnh(0=G[) */

		char	*filename;
		HANDLE	iconhandle;

	filename = (char *)POP_A_OF_S;

	iconhandle = LoadImage(
		NULL,
		filename,
		IMAGE_ICON,
		32,
		32,
		LR_LOADFROMFILE );

	PUSH_Q( iconhandle, 0 );
}


#if 0
	/* ;WORD ACRύXO */

	/* ̋@\Tcl/TkRA(tk81.dll)Ɉړ(wn iconbitmap) */
	/* ̂͐ɂ̂ł΂炭͒`Ă            */

        /* (hwnd, ACRnh  Õ\[X) */

		HWND	hwnd;
		HANDLE	iconhandle;
		int	result;

	iconhandle = (HANDLE)POP_U_OF_Q;
	hwnd = (HWND)POP_U_OF_Q;

	result = SetClassLong(hwnd, GCL_HICON,   (LONG)iconhandle ); 
	result = SetClassLong(hwnd, GCL_HICONSM, (LONG)iconhandle ); 

	PUSH_Q( result, 0 );
#endif


/* ------------------------------------------------------------------ */
PRIVATE void
    c_do_one_event( void )           /* ;WORD ̃CxgO */
{
		int	retcode;

        /* (.  ) */

	retcode = do_one_event();
	PUSH_Q( retcode, 0 );
}



/* -------------------------------------------------------------------- */
void
    c_display_size_x( void )	/* ;WORD fBXvCTCYw */
{
	PUSH_Q( display_size_x, 0 );
}

void
    c_display_size_y( void )	/* ;WORD fBXvCTCYx */
{
	PUSH_Q( display_size_y, 0 );
}

void
    c_tcltk_nest( void )	/* ;WORD Tcl/TklXg */
{
	PUSH_Q( RestartEnvCount, 0 );
}

void
    c_control_imm( void )	/* ;WORD c_control_IMM */
{
	/* (WinHandle, 1/0 -> .) */

		int		ON_FLAG;
		HWND		hWnd;
	        HIMC		hImc;

	ON_FLAG = (int)POP_U_OF_Q;
	hWnd = (HWND)POP_U_OF_Q;

        hImc = ImmGetContext( hWnd );
        ImmSetOpenStatus( hImc, ON_FLAG );
        ImmReleaseContext( hWnd, hImc );
}

void
    c_utf_to_sjis( void )	/* ;WORD tse|rihrϊ */
{
	/* (UTF -> SJIS) */

		char	*utf_string;
		size_t	utf_len;
		char	*sjis_string;
		size_t	sjis_len;

	utf_len = POP_C;
	utf_string = (char *)POP_A;

	sjis_string = utf_to_sjis( utf_string, utf_len );
	sjis_len = strlen( sjis_string );

	PUSH_S( sjis_string, sjis_len );
}

void
    c_sjis_to_utf( void )	/* ;WORD rihr|tseϊ */
{
	/* (sjis -> utf) */

		char	*sjis_string;
		size_t	sjis_len;
		char	*utf_string;
		size_t	utf_len;

	sjis_len = POP_C;
	sjis_string = (char *)POP_A;

	utf_string = sjis_to_utf( sjis_string, sjis_len );
	utf_len = strlen( utf_string );

	PUSH_S( utf_string, utf_len );
}


/*;GLOBAL*/                    /* ÔߍŌGLOBALɂĂ */


/* end of 'mind2tcl.c' */
