/*===========================================================================*/
/*                                                                           */
/*                    Mind version 7.0 runtime library                       */
/*                                                                           */
/*                 Copyright (C) 1994 by Rigy Corporation                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*  t@C: osfunc.c                                                     */
/*  @\      : nrƂ̃C^[tF[X                               */
/*  쐬      : Ћ (1994.09.01)                                          */
/*---------------------------------------------------------------------------*/


/* L^ -/

1994.07.07	VK쐬D

1996.02.19	ANSIWɂ邽߁Amin(),max() }NŒ`
		ɂ. (RpCĂ)

1996.02.23	sysReadFixedSize()̃G[^[萔ύX.
		"ACCESsERROR""EFAULT" (unixłg悤ȃV{ɂ)

		kernelƋp^錾t@C"common.def"CN[h
		悤ɂ.

1996.03.05	჌xt@CANZXɕύX(t@Cnhg).

1996.03.07    	printf("`%08lX`", addr) Ƃ\LQAUNIXansi
		̓G[ɂȂ̂ (ULONG) ̃LXgt.
		
		askAndGetNumber() ŎgĂȂǏϐ loc L
		ō폜.

1996.03.10	ϐ̌@\ƂĎ̓ݒu.
                - sysGetEnvTokenFirst()
                - sysGetEnvTokenNext()

1996.03.12    	sysGetEnvTokenFirst()C. ϐɒڂnull
		܂̂͂܂̂Ńobt@O悤ɂ.

1996.06.14	OS̎ʎw'osdefine.def'ɕ.

/- I */

/*PAGE*/
/*----------------------------------------------------------------------------
                               萔ƌ^`
----------------------------------------------------------------------------*/

#include "osdefine.def"

#include <stdio.h>
#include <stdlib.h>             /* atoi(), atol(), _psp, min(), max() */

  #if DOS_ENVIRONMENT
#include <sys\types.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <io.h>
  #else /*--UNIX---*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
  #endif

#include <errno.h>      	/* errno ̒l */
#include <string.h>

#include "common.def"		/* kernelƋp^錾 */
#include "osfunc.h"     	/* {\[XΉ̃wb_t@C */

#define	 STRINgINPUtSIZE    160		/* sysGetString()p̃obt@ */
#define  STRINgINPUtLENGTH  (STRINgINPUtSIZE-1)

  #if DOS_ENVIRONMENT
#define	O_FOR_OPEN        (O_RDONLY|O_BINARY)
  #else
#define	O_FOR_OPEN        (O_RDONLY)
  #endif

/*PAGE*/
/*----------------------------------------------------------------------------
                            sysOpenBinary()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode		/* ߒl:G[R[h(0Ő) */
    sysOpenBinary(
                tHandle   *filehandle,  /* 1:t@Cnhi[Ԓn */
                char      *filename	/* 2:t@C               */
                 )
{
                tErrcode   retcode;

        *filehandle = open( filename, O_FOR_OPEN );

        if ( *filehandle == -1 )                /* tHandle[int]^ł */
        {
                /* [-1]̓G[ */
                retcode = errno;
        }
        else
        {
                retcode = SUCCESS;
        }

	return retcode;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                               sysClose()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode		/* ߒl:G[R[h(0Ő) */
    sysClose(
                tHandle   filehandle		/* :t@Cnh */
             )
{
                tErrcode  retcode;

        retcode = close( filehandle );

        if ( retcode != SUCCESS )
        {	/* G[ */
                retcode = errno;
        }

	return retcode;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                               sysRead()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode			/* ߒl:G[R[h(0Ő) */
    sysRead(
                size_t	  *resultBytes,      /* 1:ђi[|C^ */
                tHandle   filehandle,	     /* 2:t@Cnh   */
                void      *buffer,           /* 3:ǂݏoAhX   */
                size_t	  requestBytes       /* 4:voCg       */
           )
{
		size_t	  result_0;
                tErrcode  retcode;

	result_0 = read( filehandle, buffer, requestBytes );

        if ( (int)result_0 == -1 )
        {       /* G[ */
                retcode = errno;
        }
        else
        {	/*  */
		*resultBytes = result_0;
                retcode = SUCCESS;
        }

        return retcode;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                            sysReadFixedSize()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode                    /* ߒl:G[R[h(0Ő) */
    sysReadFixedSize(
                tHandle   filehandle,	        /* 1:t@Cnh */
                void	  *buffer, 		/* 2:ǂݏoAhX */
                size_t 	  requestBytes		/* 3:ǂݏoTCY   */
                    )
{
                size_t	  resultBytes;
		tErrcode  retcode;

        retcode = sysRead( &resultBytes, filehandle, buffer, requestBytes );

        if ( retcode == SUCCESS )
	{
                /* OSt@NVR[͐탊^[ */
                /* voCg𖞑Ă邩     */
                if ( resultBytes != requestBytes )
		{
                        /* voCgANZXł */
                        retcode = ENOSPC;       /* s */
		}
	}

        return retcode;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                                sysSeek()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode		/* ߒl:G[R[h(0Ő) */
  sysSeek(
                tHandle   filehandle,	/* 1:t@Cnh */
                tLocation location      /* 2:ݒʒu         */
          )
{
                tErrcode  retcode;
                tLocation newLoc;

        newLoc = lseek( filehandle, location, SEEK_SET );

        if ( newLoc == -1L )                    /* шʒu[-1]̓G[	 */
        {	/* G[ */
		retcode = errno;
        }
        else
        {	/*  */
		retcode = SUCCESS;
        }

        return retcode;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                              sysSeekEnd()
----------------------------------------------------------------------------*/

PUBLIC tErrcode			/* ߒl:G[R[h(0Ő) */
  sysSeekEnd(
                tLocation *newLoc,      /* 1:шʒui[Ԓn */
                tHandle    filehandle,	/* 2:t@Cnh */
		tLocation  location     /* 3:̋   */
            )
{
		tErrcode  retcode;
		
        *newLoc = lseek( filehandle, location, SEEK_END );

        if ( *newLoc == -1L )			/* шʒu[-1]̓G[	 */
        {	/* G[ */
		retcode = errno;
        }
        else
        {	/*  */
		retcode = SUCCESS;
        }

	return retcode;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                         ϐg[N̐؂o
-----------------------------------------------------------------------------*/

#define ENVIRONMENT_SIZE 2048
PRIVATE char envBuffer[ENVIRONMENT_SIZE+1];

PUBLIC  UCHAR *                     /* ߒl:g[Nւ̃|C^(NULL=error) */
    sysGetEnvTokenFirst(
                UCHAR   *key                  /* :L[[hւ̃|C^ */
                       )
{
                UCHAR   *value;
                UCHAR   *token;

        value = getenv( key );
        if ( value == NULL )
        {
                return NULL;                    /* L[Ȃ */
        }

        strncpy( envBuffer, value, ENVIRONMENT_SIZE );
	envBuffer[ENVIRONMENT_SIZE] = 0;	   /* NULLI[ */

  #if DOS_ENVIRONMENT
        token = strtok( (char *)envBuffer, " ,;");  /* NULLԂƂ */
  #else /*---UNIX--*/
        token = strtok( (char *)envBuffer, " ,:");  /* NULLԂƂ */
  #endif

        return token;
}

PUBLIC  UCHAR *                     /* ߒl:g[Nւ̃|C^(NULL=error) */
    sysGetEnvTokenNext( void )
{
                UCHAR   *token;

  #if DOS_ENVIRONMENT
        token = (UCHAR *)strtok( NULL , " ,;");	    /* NULLԂƂ */
  #else /*---UNIX--*/
        token = (UCHAR *)strtok( NULL , " ,:");	    /* NULLԂƂ */
  #endif

        return token;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                             sysDumpMemory()
----------------------------------------------------------------------------*/

#if DEBUG_OSFUNC

PUBLIC  void			/* ߒl: */
    sysDumpMemory(
                void     *memBlock, 	/* 1:AhX */
                size_t	  memSize   	/* 2:TCY         */
                 )
{
		unsigned char  *addr;
		size_t         oneSize;
		
	addr = (unsigned char *)memBlock;
	while( memSize )
	{
		oneSize = min( memSize, 16 );
		memSize -= oneSize;
		printf( "%08lX :", (ULONG)addr );
		while( oneSize )
		{
			printf( " %02X", *addr++ );
			oneSize--;
		}
		printf( "\n" );
	}
}

PUBLIC  void			/* ߒl: */
    sysDumpMemoryWord(
                void     *memBlock, 	/* 1:AhX */
                size_t	  memSize   	/* 2:TCY         */
                     )
{
		unsigned short *addr;
		size_t         oneSize;
		
	addr = (unsigned short *)memBlock;
	memSize = (memSize & -2);
	while( memSize )
	{
		oneSize = min( memSize, 16 );
		memSize -= oneSize;
		oneSize = oneSize/2;
		printf( "%08lX :", (ULONG)addr );
		while( oneSize )
		{
			printf( " %04X", *addr++ );
			oneSize--;
		}
		printf( "\n" );
	}
}

/*PAGE*/
/*----------------------------------------------------------------------------
                              sysGetString()
------------------------------------------------------------------------------
Purpose:     	R\[foCXPs̕
Description:	pґœ͗p̃obt@pӂ邪AʂNULLobt@
		AhXƂĎw肷邱ƂŁA{֐̃obt@g
		łD
----------------------------------------------------------------------------*/

PUBLIC  char *        		/* ߒl:͕ւ̃|C^ */
    sysGetString(
    		char    *usrBuffer,	/* 1:͕obt@ */
		size_t  limit		/* 2:̓~bg */
    		)
{        
		static char   sysBuffer[STRINgINPUtSIZE];
		       char  *buffer;
		     size_t   length;

	/* ---------------------------------------- */
	/* :~bg̓obt@TCY  */
	/*    Ȃlw肷邱ƁD		    */
        /* :fgets()ŗpĂ邪A */
        /*    \nȂ_Ⴄ.		    */
	/* :obt@̃AhXƂNULL  */
	/*    w肷邱ƂŁA֐ŗpӂo  */
	/*    bt@gƂłB̏  */
	/*    ͓xČĂԂƍŏ̓ej  */
	/*    ̂Œӂ邱.               */
	/* ---------------------------------------- */

	if ( usrBuffer == NULL || limit == 0 )	/* [Uobt@NULLȂ */
	{
		buffer = sysBuffer;		/* obt@g */
		limit  = STRINgINPUtLENGTH;	/* obt@̗e */
	}
	else
	{
		buffer = usrBuffer;		/* NULLłȂ΂g */
	}
	
	fgets( buffer, (limit+1), stdin );
	length = strlen( buffer );		/* ̒m   */
	if ( buffer[length-1] == '\n' )		/* sR[hȂ */
	{
		buffer[length-1] = '\0';	/* 폜 */
	}
        return buffer;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                                 sysPause()
----------------------------------------------------------------------------*/

PUBLIC  void                            /* ߒl: */
    sysPause( void )                    /* : */
{        
		static char  keybuff[4];

        printf("Pause:");			/* vvg\  */
        sysGetString( keybuff, 3 );		/* [Enter]҂       */
}

/*PAGE*/
/*----------------------------------------------------------------------------
                                 ̑
----------------------------------------------------------------------------*/

PUBLIC unsigned int		/* ߒl:^U */
    ask(
                char	*message	/* :╶ */
       )
{
		static char  buffer[3];
		
	/* ----------------------------------------------------- */
	/* :̎󂯎ɓOɃobt@tbV */
	/* ----------------------------------------------------- */
	fflush( stdin );				/* keybuftbV */
        printf( "%s(Y/N[Enter]):", message ); 		/* bZ[Wo͂ */
        sysGetString( buffer, 2 );			/* ͂     */
        return ( buffer[0]=='Y'||buffer[0]=='y' );
}

PUBLIC char *			/* ߒl:͂ւ̃|C^ */
    askAndGetString(
                char 	*message,	/* 1:╶			  */
		char 	*buff,		/* 2:L[̓obt@	  */
		int   	limit		/* 3:͐(NULL܂܂) */
                   )
{
	/* ----------------------------------------------------- */
	/* :̎󂯎ɓOɃobt@tbV */
	/* ----------------------------------------------------- */
	fflush( stdin );				/* keybuftbV */
        printf( "%s(only[Enter] to calcel):", message);	/* bZ[Wo͂ */
        return sysGetString( buff, limit );		/* ͂     */
}

PUBLIC long			/* ߒl:l(long -1:P^[) */
    askAndGetNumber(
    		char *message		/* :╶ */
    		   )
{
		static char	numstr[20];

	/* ----------------------------------------------------- */
	/* :̎󂯎ɓOɃobt@tbV */
	/* ----------------------------------------------------- */
        askAndGetString( message, numstr, 19 );
        if ( numstr[0] == '\0' )
        {
                return -1L;
        }
        else
        {
        	return atol( numstr );
        }
}

PUBLIC tLocation		/* ߒl:l(long -1:P^[) */
    askAndGetLocation(
    		char *message		/* :╶ */
    		     )
{
    	return (tLocation)( askAndGetNumber(message) );
}

#endif


/* end of "osfunc.c" */
