#include <windows.h>
#include <stdarg.h>
#include <stdlib.h>	/* for atoi() */

#include "wincons.h"
#include "jumpbufmax.h"
#include "kermain.h"

#define startup_monitor 0



/*-----------------------------------------------------------------------------
                              CEGg
-----------------------------------------------------------------------------*/


#include "setargv.c"


extern int PASCAL
WinMain(	HINSTANCE	hInstance,
		HINSTANCE	hPrevInstance,
		LPSTR		lpCmdLine,
		int		nCmdShow )
{
		static char myname[MAX_PATH];
		static char startuptclname[MAX_PATH];
		char 	   *mynamep[1];
		char	  **argv;
		int	    argc;

	/* -- get my args -- */

	GetModuleFileName(NULL, myname, sizeof(myname));
	prepare_standardout();

  #if startup_monitor
	startwinconsole();	/* ň񂾂sĂ */
	winprintf("-- I am mindrunt(Win NOT GUI - silent) --\n");
	winprintf("cmdline=%s\n", lpCmdLine );
	winprintf("myname =%s\n", myname);
	winpause();
  #endif

	CommandLine = lpCmdLine;		/* ptrdef.cŕϐ` */

	setargv( &argc, &argv, myname, lpCmdLine, NO_DQUOTE );
	Argc = argc;     			/* ptrdef.cŕϐ` */
	Argv = argv;     			/* ptrdef.cŕϐ` */

  #if startup_monitor
	{
		int	i;
		winprintf("--------------------\n");
		for (i=0;i<Argc;i++)
		{
			winprintf("Arg%d=[%s]\n",i,Argv[i]);
		}
		winprintf("--------------------\n");
		winpause();
	}
	endwinconsole();
  #endif

        if ( Argc<2 || strcmp(Argv[1],"")==0 )
       	{
		startwinconsole();
		winprintf("No M-code file name.\n");
		winpause();
		ExitProcess( 1 );
        }

	execute_main_word( Argv[1] );	/* FMR[ht@C */
}

